'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               GDImage.dll                                |
'|             Graphic control compatible GDI, GDIPLUS, OpenGL              |
'|                                                                          |
'|                              Version 6.65                                |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                         copyright(c) 2005-2016                           |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-16-2005 (MM-DD-YYYY)            |
'|                        Last revised : 09-29-2016 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
'
'****************************************************************************
' CONSTANTS
'
  $GDIPLUSIMG        = ".DIB.EMF.GIF.JPG.JPEG.PNG.TIF.TIFF.WMF."
  $GDIPLUSEXT        = $GDIPLUSIMG + "BMP.ICO."
'
  $zLim              = "|"
  $Anti              = "\"
  $Dot               = "."
  $GDImageClassName  = "ZIMAGECTRL"  ' Class name for GDImage standard control.
  $GLImageClassName  = "ZOPENGLCTRL" ' Class name for OpenGL control.

' Internal GDImage structure being used to store details about each sprite object.
  %METADATA_SIZE   = 2048 '//See it in GDImage.inc
  TYPE ZOBJECT
      hWnd        as long
      objType     as long
      metacount   as long
      metadata    AS STRING * %METADATA_SIZE

      useFont     as asciiz * 64'128 '//5.03
      extrabyte   AS STRING * 64     '//5.03 Reserved for future extension

      useSize     as long
      fontFam     as long
      curFont     as long
      strFormat   as long
      useARGB     as long
      use3D       as long
      x1          as long ' x top coordinate
      y1          as long ' y top coordinate
      x2          as long ' object width
      y2          as long ' object height
      visible     as long
      order       as long
      locked      AS BYTE

      ID          as long      '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< SIZEOF(ZOBJECT) - 131 + 1
      Style       as long
      Bitmap      as long
      Region      as long
      objLabel    AS STRING * 64
      xCapture    AS INTEGER   ' WORD   '//4.04
      yCapture    AS INTEGER   ' WORD   '//4.04
      opacity     AS BYTE      ' PNG variable opacity
      scale       AS SINGLE    '//2.10
      clone       as long      '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< SIZEOF(ZOBJECT) - 42 + 1
      xP          AS INTEGER   ' WORD   '//4.04 '//2.11
      yP          AS INTEGER   ' WORD   '//4.04 '//2.11
      angle       AS WORD      '//2.11
      quality     AS BYTE      '//2.11
      flipmode    AS BYTE      '//3.00
      userotate   AS BYTE      '//3.00
      selected    AS BYTE      '//3.02
      hidden      AS BYTE      '//3.56

      brightness  AS BYTE      '//4.05
      contrast    AS BYTE      '//4.05
      red         AS BYTE      '//4.05
      green       AS BYTE      '//4.05
      blue        AS BYTE      '//4.05
      hue         AS BYTE      '//4.05

      FrameCount  AS BYTE      '//4.16
      FrameToUse  AS BYTE      '//4.16

      anchor      AS BYTE      '//5.00
      nLeft       AS INTEGER   '//5.00
      nTop        AS INTEGER   '//5.00
      nRight      AS INTEGER   '//5.00
      nBottom     AS INTEGER   '//5.00
      centerx     AS INTEGER   '//5.00
      centery     AS INTEGER   '//5.00

      linked      as long      '//5.03 Link multiple sprite objects together   

      PrivateFont AS BYTE      '// 7.00

      reserved    AS STRING * 1' 19 ' 27' 28 ' 26
  END TYPE ' 2368 bytes
'//   WARNING in case of change into the ZOBJECT structure that would impact its size,
'//   don't forget to update the "zItemFromID" and "zCloneFromID" functions!!!

  TYPE ZPOINTS
      x AS INTEGER
      y AS INTEGER
  END TYPE

  TYPE CHARTFONT
      hWnd            as long
      hTexture        as long
      CharWidth(255)  AS BYTE
      nFontSize       as long
      szFontName      as asciiz * 64
  END TYPE

'
'****************************************************************************
' Version 1.00
' --------------------
' Load the GDImage.dll
' --------------------
' Must be done in the WinMain section BEFORE USING any of the GDImage function.
' Parameter: None
  DECLARE FUNCTION RegisterGDImageClass LIB "GDIMAGE.DLL" ALIAS "RegisterGDImageClass" () as long
' Return:
' 0 = means failure, any other value means registered.
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Default function to create a GDImage control
' (Alias zCreateImageCtrl)
  DECLARE FUNCTION ZI_CreateWindow LIB "GDIMAGE.DLL" ALIAS "ZI_CreateWindow" ( _
  byval hParent as long, _  ' The Window/Dialog container
  byval x as long, _        ' The control top left corner horizontal location
  byval y as long, _        ' The control top left corner vertical location
  byval xW as long, _       ' The control width
  byval yH as long, _       ' The control height
  byval ControlID as long _ ' The control unique IDentifier
  ) as long
' Return:
' The handle of the newly created control
'
' --------------------------------------
' Alternate methode using CreateWindowEx
' --------------------------------------
' Style   = %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER
' StyleEx = 0
' CALL CreateWindowEx(StyleEx, _
'                    "ZIMAGECTRL", _                 ' window class name
'                    "e:\pictures\image.png<fit>", _ ' Optional FullPathName to picture
'                     Style, _                       ' window style
'                     10, _                          ' initial x position
'                     10, _                          ' initial y position
'                     150, _                         ' Calculate Window Width
'                     150, _                         ' Calculate Window Height
'                     hMain, _                       ' parent window handle
'                     %ID_THUMBCTRL, _               ' ControlID
'                     GetModuleHandle(""), _         ' program instance handle
'                     byval 0)                       ' creation parameters
'
' ---------------------------------------
' Alternate methode using DDT CONTROL ADD
' ---------------------------------------
'  CONTROL ADD "ZIMAGECTRL", _
'              hDlg, _
'              %IDC_CUSTOMCONTROL, _
'              "e:\picture.jpg", _
'              10, 10, 640, 480, _
'              %WS_CHILD OR %WS_VISIBLE OR %WS_HSCROLL OR %WS_VSCROLL, _
'              %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR
'
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Display the common file selector dialog using thumbnail preview for the supported graphic format.
' (Alias zImageLoadDialog)
  DECLARE FUNCTION ZI_LoadDialog LIB "GDIMAGE.DLL" ALIAS "ZI_LoadDialog" ( _
  byval hParent as long _              ' The parent window handle.
  ) AS STRING
' Return:
' The FullPathName of the selected picture
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Display the common save to file dialog providing a valid hGDImageCtrl handle
' (Alias zImageSaveDialog)
  DECLARE FUNCTION ZI_SaveDialog LIB "GDIMAGE.DLL" ALIAS "ZI_SaveDialog" ( _
  byval hParent as long, _             ' The parent window handle.
  byval hGDImageCtrl as long _         ' The GDImage control handle.
  ) as long
' Return:
' Successfull ErrCode = 0
' Error       ErrCode
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Save the content of a GDImage control to any of the supported graphic format
' Must be a supported graphic format, see $GDIPLUSEXT.
  DECLARE FUNCTION ZI_SaveToFile LIB "GDIMAGE.DLL" ALIAS "ZI_SaveToFile" ( _
  zFullPathName as asciiz, _           ' Full path name of the graphic file to save.
  byval hGDImageCtrl as long, _        ' The GDimage control handle.
  OPTIONAL byval JpegQuality as long _ ' Optional JPEG encoding quality 1-100:
  ) as long                            ' Default 0 = QalityMax = 100
' Return:
' Successfull ErrCode = 0
' Error       ErrCode
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Set the image file to use with the control.
' Must be a supported graphic format, see $GDIPLUSEXT.
' (Alias zSetImageFromFile)
  DECLARE SUB ZI_SetFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_SetFromFile" ( _
  byval hGDImageCtrl as long, _  ' The GDimage control handle.
  zFullPathName as asciiz _      ' Full path name to the graphic file to display
  )
' This function is the same than using :
' CALL SendMessage (hCtrl, %WM_SETTEXT, 0, STRPTR(FullPathName$))
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Set property of a GDImage control
' (Alias zGetProperty)
  DECLARE FUNCTION ZI_GetProperty LIB "GDIMAGE.DLL" ALIAS "ZI_GetProperty" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval nProperty as long _     ' A %ZI_ predefined constant (see the list below)
  ) as long
' Return:
' The matching property value
'
' Get property from a GDImage control
' (Alias zSetProperty)
  DECLARE SUB ZI_SetProperty LIB "GDIMAGE.DLL" ALIAS "ZI_SetProperty" ( _
  byval hGDImageCtrl as long, _ ' The control handle.
  byval nProperty as long, _    ' A %ZI_ predefined constant (see the list below)
  byval Parameter as long _     ' A parameter matching the type of property to set.
  )
'
' See below the list of GDImage properties:
' Note: Constants prefixed with %ZI_ are for IMAGE control
  %ZI_DC             = 1  ' Internal DC
  %ZI_Bitmap         = 2  ' Memory Bitmap
  %ZI_Horizontal     = 3  ' Horizontal scrolling position
  %ZI_Vertical       = 4  ' Vertical scrolling position
  %ZI_GradientTop    = 5  ' Top gradiant color backgroud
  %ZI_GradientBottom = 6  ' Bottom gradiant color backgroud

  %ZI_FitToWindow    = 7  ' Resize the image to fit the view port
                          ' And use any of this constant as Parameter
                           %ZI_QualityDefault = -1
                           %ZI_QualityGood    = 1  ' Best performance
                           %ZI_QualityHigh    = 2  ' Best rendering quality
' DO NOT use or alter these properties!
  %ZI_PaintDC        = 8  ' Internal DC
  %ZI_PaintBitmap    = 9  ' Memory Bitmap
  %ZI_Reserved       = 10 ' Animated frame parameters : LOWRD = FrameWidth, HIWRD = FrameCount

  %ZI_ZoomWindow     = 11 ' Version 1.41
  %ZI_ZoomFactor     = 12 ' Version 1.41
  %ZI_Orientation    = 13 ' Version 1.41

  %ZI_FlagByte       = 14 ' Version 2.00 4 bytes reserved for flag
      %TOOL_CROP     = 1          ' Stored in the first byte
      %TOOL_CUTTER   = 2          ' Stored in the first byte
      %TOOL_PENCIL   = 4          ' Stored in the first byte
      %TOOL_FLOOD    = 8          ' Stored in the first byte
      %TOOL_AIRBRUSH = 16         ' Stored in the first byte
      %TOOL_PIPE     = 32         ' Stored in the first byte
      %TOOL_MOUSE    = 64         ' Stored in the first byte
      %TOOL_UNKNOWN  = 128        ' Stored in the first byte

  %Extend_cbWndExtra = %ZI_FlagByte ' %ZI_Orientation ' %ZI_Reserved

  %ZI_GDIPLUSHANDLE  = 1  ' Load GDIPLUS Image handle

  %ZD_MAPCOLORFROM   = &h807F80   ' Maping color for 32-bit alphablending
  %ZI_MAPCOLORFROM   = &hFF807F80 ' Maping color for 32-bit alphablending
  %ZI_MAPCOLORTO     = &hFF808080 ' Maping color for 32-bit alphablending
  %ZI_MAPCOLORNULL   = &h00807F80 ' Maping color for 32-bit alphablending
  %ZI_MAPTRANSCOLOR  = &h807F80   ' Transparent maped color for 32-bit alphablending
'
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Paint the background of a GDImage control
' see property %ZI_GradientTop
' and property %ZI_GradientBottom
' (Alias zGradientPaintDC)
  DECLARE SUB ZI_GradientPaintDC LIB "GDIMAGE.DLL" ALIAS "ZI_GradientPaintDC" ( _
  byval hDC as long, _      ' A Windows DC (do not use ZI_GetDC except if you want to paint over the image)
  byval x as long, _        ' The top left corner horizontal location
  byval y as long, _        ' The top left corner vertical location
  byval xW as long, _       ' The width
  byval yH as long, _       ' The height
  byval TopRGB as long, _   ' The RGB color to use for the top
  byval BottomRGB as long _ ' The RGB color to use for the bottom
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Retrieve bitmap size from a supported GDI+ disk file (do not load the image)
' (Alias zGetImageSize)
  DECLARE SUB ZI_GetImageSizeFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageSizeFromFile" ( _
  zFullPathName as asciiz, _      ' The name of the graphic file to detect size
  imgWidth as long, _             ' Width of the picture
  imgHeight as long _             ' Height of the picture
  )
' See: ZI_AdjustWindowRect to adjust the client size of a GDImage control.
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Get the private DC of GDImage control
  DECLARE FUNCTION ZI_GetDC LIB "GDIMAGE.DLL" ALIAS "ZI_GetDC" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Return:
' The private DC of the GDImage control
' You can use this DC to draw on the GDImage memory bitmap using standard GDI command.
'
' DO NOT release this DC and AVOID to use DELETEDC on it!
'****************************************************************************
'
'****************************************************************************
' Version 1.04
' Get the GDImage.dll internal version number
' (Alias zGDImageVersion)
  DECLARE FUNCTION ZI_Version LIB "GDIMAGE.DLL" ALIAS "ZI_Version" () AS STRING
' Return:
' The version number of the form "#.#"
'****************************************************************************
'
'****************************************************************************
' Version 1.04
' Copy image to clipboard.
' (Alias zClipboardCopy)
  DECLARE FUNCTION ZI_ClipboardCopy LIB "GDIMAGE.DLL" ALIAS "ZI_ClipboardCopy" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.04
' Paste image from clipboard.
' (Alias zClipboardPaste)
  DECLARE FUNCTION ZI_ClipboardPaste LIB "GDIMAGE.DLL" ALIAS "ZI_ClipboardPaste" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.05
' Compute the client size for a specific GDImage control
' that will match exactly the picture size
  DECLARE SUB ZI_AdjustWindowRect LIB "GDIMAGE.DLL" ALIAS "ZI_AdjustWindowRect" ( _
  byval StyleEx as long, _ ' The CreateWindowEx Extended Style.
  imgW as long, _          ' Width of the image.
  imgH as long, _          ' Height of the image.
  byval Style as long _    ' The CreateWindowEx Style.
  )
' See: ZI_GetImageSizeFromFile to get an image size without loading it.
'****************************************************************************
'
'****************************************************************************
' Version 1.05
' Set the value for the alpha channel of GDImage layered window.
' Note: A layered window MUST use the POPUP style.
  DECLARE FUNCTION ZI_SetLayeredAlpha LIB "GDIMAGE.DLL" ALIAS "ZI_SetLayeredAlpha" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval TransLevel AS BYTE _    ' The translucency level ranging from 0 to 255
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.06
' Create a window using a transparent color to build a region on the fly
' You can use this command with either a POPUP or CHILD window .
  DECLARE FUNCTION ZI_CreateWindowFromImage LIB "GDIMAGE.DLL" ALIAS "ZI_CreateWindowFromImage" ( _
  byval Style as long, _           ' The CreateWindowEx Style.
  zFullImagePath as asciiz, _      ' The name of an image file.
  byval x as long, _               ' The top left corner horizontal location
  byval y as long, _               ' The top left corner vertical location
  byval hParent as long, _         ' The main window parent handle
  byval UseID as long, _           ' Warning, DO NOT use an ID when using the %WS_POPUP style.
  byval StyleEx as long, _         ' The CreateWindowEx Extended Style.
  byval UseTransColor as long _    ' The transparent color that will be used to create the region.
  ) as long
' Return:
' The new window handle or NULL if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.07
' To retrieve the image size of specific GDimage control
  DECLARE SUB ZI_GetImageSizeFromControl LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageSizeFromControl" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  imgW as long, _               ' Width of the picture.
  imgH as long _                ' Height of the picture.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.07
' To force immediate refresh of a GDImage control display
  DECLARE SUB ZI_UpdateWindow LIB "GDIMAGE.DLL" ALIAS "ZI_UpdateWindow" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval EraseFlag as long _     ' Boolean flag to erase first the background.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.11
' To anchor a GDImage control to a specific location when resizing parent window
' See: ANCHOR.GIF
  DECLARE FUNCTION ZI_SetAnchorMode LIB "GDIMAGE.DLL" ALIAS "ZI_SetAnchorMode" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval AnchorMode as long _    ' The anchor mode (see below)
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'
' Version 1.12
' The function has been enhanced to anchor any type of control:
' button, static, edit, listbox, etc.
'
' ANCHOR Flags:
  %ANCHOR_NONE                = 0
  %ANCHOR_LEFT                = %ANCHOR_NONE
  %ANCHOR_WIDTH               = 1
  %ANCHOR_RIGHT               = 2
  %ANCHOR_CENTER_HORZ         = 3
  %ANCHOR_HEIGHT              = 4
  %ANCHOR_HEIGHT_WIDTH        = 5
  %ANCHOR_HEIGHT_RIGHT        = 6
  %ANCHOR_BOTTOM              = 7
  %ANCHOR_BOTTOM_WIDTH        = 8
  %ANCHOR_BOTTOM_RIGHT        = 9
  %ANCHOR_CENTER_HORZ_BOTTOM  = 10
  %ANCHOR_CENTER_VERT         = 11
  %ANCHOR_CENTER_VERT_RIGHT   = 12
  %ANCHOR_CENTER              = 13
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Convert COLOR to 256 shade of GRAY
  DECLARE FUNCTION ZI_ConvertToGray LIB "GDIMAGE.DLL" ALIAS "ZI_ConvertToGray" ( _
  byval hGDImageDC as long _  ' A GDImage DC (ZI_GetDC) or any DC using an associated memory bitmap
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Replace a RGB color with another RGB color, using a Device Context handle
  DECLARE SUB ZI_ReplaceRGBColor LIB "GDIMAGE.DLL" ALIAS "ZI_ReplaceRGBColor" ( _
  byval hGDImageDC as long, _  ' A GDImage DC (ZI_GetDC) or any DC using an associated memory bitmap
  byval WasRGBColor as long, _ ' The RGB color to replace
  byval NewRGBColor as long _  ' The new RGB color to use
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Compute the number of unique color(s) of an image shown in a GDImage control.
  DECLARE FUNCTION ZI_ColorCount LIB "GDIMAGE.DLL" ALIAS "ZI_ColorCount"( _
  byval hGDImageCtrl as long _ ' The GDImage control handle
  ) as long
' Return:
' The number of unique color(s) being used in the image.
' Note: Overlay objects are not considered in the computation.
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Print image only, self centered on the paper sheet.
' Print will fit the paper size
  DECLARE FUNCTION ZI_PrintImage LIB "GDIMAGE.DLL" ALIAS "ZI_PrintImage" ( _
  byval hGDImageCtrl as long _ ' The GDImage control handle
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Print image + annotation, self centered on the paper sheet.
' Print will fit the paper size
  DECLARE FUNCTION ZI_PrintFull LIB "GDIMAGE.DLL" ALIAS "ZI_PrintFull" ( _
  byval hGDImageCtrl as long _
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Read image from a provided text buffer (STREAMING)
  DECLARE FUNCTION ZI_LoadImageFromStream LIB "GDIMAGE.DLL" ALIAS "ZI_LoadImageFromStream" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval pBufferData AS BYTE PTR, _     ' Pointer to buffer holding data.
  byval BufferSize as long _           ' Size of the buffer.
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' To load any of the supported graphic format as a program resource
' directly to a GDImage control as background.
  DECLARE FUNCTION ZI_LoadFromResource LIB "GDIMAGE.DLL" ALIAS "ZI_LoadFromResource" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  zResourceName as asciiz _            ' The resource name identifier.
  ) as long
' Return:
' IF the GDImage control handle is omited the returned parameter is a Bitmap handle.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' To GET the Width and Height of a STANDARD BITMAP
  DECLARE SUB ZI_GetBitmapSize LIB "GDIMAGE.DLL" ALIAS "ZI_GetBitmapSize" ( _
  byval hBitmap as long, _   ' Handle to a standard bitmap.
  BitmapWidth as long, _     ' The width of the bitmap.
  BitmapHeight as long _     ' The Height of the bitmap.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Create a valid GDI BITMAP handle from FILE using any of the supported GDImage format.
  DECLARE FUNCTION ZI_CreateBitmapFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_CreateBitmapFromFile" ( _
  zFullImagePath as asciiz, _      ' The name of an image file.
  BitmapWidth as long, _           ' The width of the bitmap.
  BitmapHeight as long _           ' The Height of the bitmap.
  ) as long
' Return:
' A valid GDI bitmap handle (do not confuse GDI bitmap handle and GDI+ Image handle).
' Important:
' You must use DeleteObject(GDIBitmapHandle) when you do not need it anymore.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' To load the specified bitmap resource from the module's executable file.
' The resource can use any of the supported GDImage graphic format.
' (See RESOURCE.RC example)
  DECLARE FUNCTION ZI_LoadBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_LoadBitmap" ( _
  zResourceName as asciiz _            ' The resource name identifier.
  ) as long
' Return:
' A valid GDI bitmap handle (do not confuse GDI bitmap handle and GDI+ Image handle).
' Important:
' You must use DeleteObject(GDIBitmapHandle) when you do not need it anymore.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Create a valid GDIPLUS Image handle from FILE using any of the supported GDImage format.
  DECLARE FUNCTION ZI_CreateImageFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_CreateImageFromFile" ( _
  zFullPathName as asciiz, _           ' Full path name to the graphic file to load.
  imageWidth as long, _                ' The image width.
  imageHeight as long, _               ' The image height.
  byval RemoveARGBColor as long, _     ' Boolean flag use %TRUE to remove ARGBColorToRemove.
  byval ARGBColorToRemove as long _    ' The ARGB color to remove.
  ) as long
' Return:
' A valid GDIPLUS Image handle (do not confuse with a GDI Bitmap handle),
' or NULL if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Create an empty image background (Bitmap) into a GDImage control.
' Use it to perform direct drawing, everything lying out of it (overlay objects) would be clipped.
  DECLARE FUNCTION ZI_CreateImageBackground LIB "GDIMAGE.DLL" ALIAS "ZI_CreateImageBackground" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval BitmapWidth as long, _         ' The width of the bitmap.
  byval BitmapHeight as long _         ' The Height of the bitmap.
  ) as long
' Return:
' A valid GDImage DC (ZI_GetDC) you can use to draw in.
' Note: After drawing into the provided DC, use ZI_UpdateWindow to refresh the display.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Remove a GDIPLUS Image object from memory.
  DECLARE SUB ZI_DeleteImageObject LIB "GDIMAGE.DLL" ALIAS "ZI_DeleteImageObject" ( _
  hImage as long _                     ' A valid GDIPLUS Image handle
  )
' Comment:
' Use it as you would do with DeleteObject for a standard BITAMP handle.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Perform image rotation in the specified DC, using a GDIPLUS Image handle.
  DECLARE SUB ZI_RotateImage LIB "GDIMAGE.DLL" ALIAS "ZI_RotateImage" ( _
  byval hDC as long, _                 ' A valid Device Context
  byval hImage as long, _              ' A valid GDIPLUS Image handle
  byval x as long, _                   ' The X coordinate
  byval y as long, _                   ' The Y coordinate
  byval AngleDegree as long, _         ' The rotation angle in degree to use
  byval UseAlpha as long _             ' The Alpha channel value (use 255 for standard opaque mode)
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Render GDIPLUS Image rotation into a specific GDImage control.
  DECLARE SUB ZI_RenderImageRotationToWindow LIB "GDIMAGE.DLL" ALIAS "ZI_RenderImageRotationToWindow" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval hImage as long, _              ' A valid GDIPLUS Image handle.
  byval x as long, _                   ' The X coordinate.
  byval y as long, _                   ' The Y coordinate.
  byval AngleDegree as long, _         ' The rotation angle in degree to use.
  byval UseAlpha as long _             ' The Alpha channel value (use 255 for standard opaque mode).
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.18
' Use a Bitmap to paint a tiled background in a specific GDImage control.
' Bitmap can provide from file or resource using any of the GDImage supported graphic format.
  DECLARE FUNCTION ZI_SetTiledBackground LIB "GDIMAGE.DLL" ALIAS "ZI_SetTiledBackground" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval UseBitmap as long _
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.18
' Retrieve the Bitmap handle being used to tile a background in a specific GDImage control.
  DECLARE FUNCTION ZI_GetTiledBackground LIB "GDIMAGE.DLL" ALIAS "ZI_GetTiledBackground" ( _
  byval hGDImageCtrl as long _         ' The GDImage control handle.
  ) as long
' Return:
' The background Bitmap handle, or NULL if there is no tiled background.
'****************************************************************************
'
'****************************************************************************
' Version 1.19
' Retrieve a copy of the entire bitmap for the selected GDImageDC,
' using a 2 dimensions array of the form (x,y) pointing directly to pixel.
' You can use the array coordinates as you would do with a standard DC,
' because pixel 0,0 is at coordinate Array(0,0).
' Once your are done with the array, the bitmap is replaced using ZI_SetDIBits.
' (see ZI_SetDIBits)
  DECLARE FUNCTION ZI_GetDIBits LIB "GDIMAGE.DLL" ALIAS "ZI_GetDIBits" ( _
  byval hGDImageDC as long, _              ' Any memory bitmap Device Context (like ZI_GetDC).
  PixelArray() as long _                   ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  ) as long
' Return:
' Null if error, else success.
' Comment:
' Each pixel use ARGB color of the form Alpha, Red, Blue, Green (reading from left to right).
'****************************************************************************
'
'****************************************************************************
' Version 1.19
' Replace a copy of a bitmap that was retrieved as a device-independent bitmap.
' (see ZI_GetDIBits)
  DECLARE FUNCTION ZI_SetDIBits LIB "GDIMAGE.DLL" ALIAS "ZI_SetDIBits" ( _
  byval hGDImageDC as long, _              ' Any memory bitmap Device Context (like ZI_GetDC).
  PixelArray() as long, _                  ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  OPTIONAL byval DoNotClearArray as long _ ' Boolean flag, %TRUE = DO NOT clear the array
  )as long
' Return:
' Null if error, else success.
'****************************************************************************
'
'****************************************************************************
' Version 1.22
' Delete the memory bitmap and device context associated to a GDImage control.
  DECLARE FUNCTION ZI_DeleteControlBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_DeleteControlBitmap" ( _
  byval hGDImageCtrl as long _        ' The GDImage control handle.
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Load a graphic file and Resize it on the fly to create a Bitmap matching a specific size.
' Version 1.26
  DECLARE FUNCTION ZI_FitImageFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_FitImageFromFile" ( _
  zFullPathName as asciiz, _      ' The name of the graphic file.
  byval BoundWidth as long, _     ' The bounding width.
  byval BoundHeight as long _     ' The bounding height.
  ) as long
' Note:
' The image will be stretched to match the bounding size, however keeping the original aspect ratio
' between width and height.
' Return:
' A valid GDI bitmap handle (do not confuse GDI bitmap handle and GDI+ Image handle).
'****************************************************************************
'
'****************************************************************************
' Version 1.36
' To render a GDIPLUS image rotation into a provided bitmap handle.
  DECLARE FUNCTION ZI_RenderRotationFromImageToBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_RenderRotationFromImageToBitmap" ( _
  byval SrceBitmap as long, _  ' A valid GDImage bitmap handle.
  byval Img as long, _         ' A valid GDImage - GDIPLUS handle.
  byval AngleDegree as long, _ ' The angle rotation in degree.
  byval UseAlpha as long _     ' The alpha channel value in the range (0-255).
  ) as long
' Return:
' A new bitmap handle that combines the GDImage Bitmap and the GDIPLUS Image handle together.
'****************************************************************************
'
'****************************************************************************
' Version 1.37
' Display an image using a grayed mask to perform gradient translucency
  DECLARE SUB ZI_DrawAlphaBlend LIB "GDIMAGE.DLL" ALIAS "ZI_DrawAlphaBlend" ( _
  byval hDCDest as long, _    ' A valid Device Context.
  byval x as long, _          ' The X coordinate.
  byval y as long, _          ' The Y coordinate.
  zImage as asciiz, _         ' Full path name to the graphic file to load.
  zMask as asciiz _           ' Full path name to the grayed mask graphic file.
  )
'****************************************************************************
'
'****************************************************************************
' Version 2.06 & 4.10
' Save a memory Bitmap to any of the supported graphic format
' Must be a supported graphic format, see $GDIPLUSEXT.
  DECLARE FUNCTION ZI_SaveBitmapToFile LIB "GDIMAGE.DLL" ALIAS "ZI_SaveBitmapToFile" ( _
  zFullPathName as asciiz, _           ' Full path name of the graphic file to save.
  byval hBitmap as long, _             ' Bitmap handle.
  OPTIONAL byval JpegQuality as long _ ' Optional JPEG encoding quality 1-100:
  ) as long                            ' Default 0 = QalityMax = 100
' Return:
' Successfull ErrCode = 0
' Error       ErrCode
'****************************************************************************
'
'****************************************************************************
'****************************************************************************
'****************************************************************************
'***                                                                      ***
'***                           DRAWING FUNCTIONS                          ***
'***                                                                      ***
'****************************************************************************
'****************************************************************************
'
' CONSTANTS prefixed with %ZD_ apply to DRAWING functions
  %ZD_TRANSCOLOR = &HFF00FF   ' Magenta color that is the default GDImage transparent color
  %ZD_TOPLEFTCOLOR = -1       ' Pixel color at location 0,0
'
' ZD_DrawText constants
  %ZD_TextHorzUp = 0          ' Horizontal text orientation
  %ZD_TextVertUp = 4          ' Vertical text orientation from bottom to top
  %ZD_TextVertDn = 8          ' Vertical text orientation from top to bottom
  %ZD_HIDE       = &H0        ' FALSE
  %ZD_SHOW       = &H1        ' TRUE

' GDImage overlay Generic STYLE must be a 2^
  %ZS_HIDDEN     = %ZD_HIDE
  %ZS_VISIBLE    = %ZD_SHOW   ' VISIBLE, same as %WS_VISIBLE
  %ZS_SCROLL     = &H2        ' MOVE with scroll bars, default is FIX (do not scroll)
  %ZS_DRAFT      = &H4        ' Draft drawing mode
  %ZS_INACTIVE   = 2          ' ZD_SetObjectHidden(ID_SIGNATURE, %ZS_INACTIVE)	'// Couldn't take the focus.

' GDImage Drawing STYLE         For all ZD_Drawxxx functions
  %ZD_DRAW_OUTLINE  = 1
  %ZD_DRAW_FILLED   = 2
  %ZD_DRAW_3DIN     = 3
  %ZD_DRAW_3DOUT    = 4
  %ZD_DRAW_OPEN     = 5
'
  %ZD_DRAW_REDRAW   = -1      ' Forces immediate redraw of parent object
  %ZD_DRAW_DEFERRED = 0       ' Defers redraw of parent object
'
'****************************************************************************
' Version 1.00
' Fills a rectangle using a specific RGB color.
  DECLARE SUB ZD_FillRect LIB "GDIMAGE.DLL" ALIAS "ZD_FillRect" ( _
  byval hGDImageDC as long, _ ' The GDImage DC (ZI_GetDC)
  byval x as long, _          ' The top left horizontal coordinate of the rectangle
  byval y as long, _          ' The top left vertical coordinate of the rectangle
  byval xW as long, _         ' The rectangle width
  byval yH as long, _         ' The rectangle height
  byval RGBcolor as long _    ' The RGB color to use
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.09
' Draw a text using a True Type Font, ARGB color, optional 3D effect and orientation
  DECLARE FUNCTION ZD_DrawTextToDC LIB "GDIMAGE.DLL" ALIAS "ZD_DrawTextToDC" ( _
  byval hGDImageDC as long, _          ' The GDImage DC (ZI_GetDC)
  zUseText as asciiz, _                ' The text to display
  byval x as long, _                   ' The X seed coordinate
  byval y as long, _                   ' The Y seed coordinate
  byval ColrARGB as long, _            ' The ARGB color to use
  zUseFont as asciiz, _                ' The "Tue Type Font" name to use
  byval UseSize as long, _             ' The size of the font in pixel
  OPTIONAL byval UseShadow as long, _  ' The shadow 3D offset
  OPTIONAL byval Orientation as long _ ' The text orientation (%ZD_TextHorzUp, %ZD_TextVertUp, %ZD_TextVertDn)
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.09
' Compute an ARGB color to ensure compatibility with GDI+
  DECLARE FUNCTION ZD_ColorARGB LIB "GDIMAGE.DLL" ALIAS "ZD_ColorARGB"( _
  byval AlphaChannel AS BYTE, _ ' The translucency level ranging from 0 to 255.
  byval ColrRGB as dword _      ' The classical RGB() color to use.
  ) as long
' Return:
' A 32-bit ARGB color.
'****************************************************************************
'
'****************************************************************************
' Version 1.09
' To retrieve the bounding size in pixel of specifc text using a True Type Font
' of a specific size.
  DECLARE FUNCTION ZD_GetTextBound LIB "GDIMAGE.DLL" ALIAS "ZD_GetTextBound" ( _
  zUseText as asciiz, _                ' The text to display.
  zUseFont as asciiz, _                ' The "Tue Type Font" name to use.
  byval UseSize as long, _             ' The size of the font in pixel.
  BYREF BoundingWidth as long, _       ' The bounding width.
  BYREF BoundingHeight as long, _      ' The bounding height.
  OPTIONAL byval Orientation as long _ ' The text orientation (%ZD_TextHorzUp, %ZD_TextVertUp, %ZD_TextVertDn).
  ) as long
' Return:
' The width and height of the bounding rectangle that matches the text being used.
'****************************************************************************
'
'****************************************************************************
' Version 1.09
' Create a TEXT overlay object.
' Each overlay object must have a unique identifier.
' TEXT overlay is independant of the image background that is not altered.
  DECLARE FUNCTION ZD_DrawTextToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawTextToCtrl" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  zUseText as asciiz, _                ' The text to display.
  byval x as long, _                   ' Top left X coordinate.
  byval y as long, _                   ' Top left Y coordinate.
  byval ColrARGB as long, _            ' The ARGB color to use.
  zUseFont as asciiz, _                ' The "Tue Type Font" name to use.
  byval UseSize as long, _             ' The size of the font in pixel.
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  OPTIONAL byval UseShadow as long, _  ' The shadow 3D offset.
  OPTIONAL byval Orientation as long _ ' The text orientation (%ZD_TextHorzUp, %ZD_TextVertUp, %ZD_TextVertDn).
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' To change on the fly the text of a TEXT overlay.
  DECLARE SUB ZD_SetObjectText LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectText" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  zUseText as asciiz _                 ' The text to display
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Create a RECTANGLE overlay object.
' Each overlay object must have a unique identifier.
' RECTANGLE overlay is independant of the image background that is not altered.
  DECLARE FUNCTION ZD_DrawRectangleToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawRectangleToCtrl" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval x as long, _                   ' Top left X coordinate.
  byval y as long, _                   ' Top left Y coordinate.
  byval xWidth as long, _              ' Rectangle width.
  byval yHeight as long, _             ' Rectangle height.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval BorderSize as long, _          ' Size of the border (can be NULL).
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE (see below).
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  ) as long
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect
'
' Return:
' TRUE (-1) if visible, FALSE (0) if not
'****************************************************************************
'
'****************************************************************************
' Create ARROW overlay object.
' Version 1.14
' Each overlay object must have a unique identifier.
  DECLARE FUNCTION ZD_DrawArrowToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawArrowToCtrl" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval SeedX as long, _               ' Swap SeedX and TargetX to select arrow orientation.
  byval SeedY as long, _               ' Swap SeedY and TargetY to select arrow orientation.
  byval TargetX as long, _             ' Swap TargetX and SeedX to select arrow orientation.
  byval TargetY as long, _             ' Swap TargetY and SeedY to select arrow orientation.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval ArrowSize as long, _           ' Size of the Arrow.
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The Drawing mode.
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  ) as long
' To change the arrow orientation, swap Seed and Target coordinates
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_FILLED                        Fill mode ONLY
'
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Create ELLIPSE overlay object.
' Version 1.14
' Each overlay object must have a unique identifier.
  DECLARE FUNCTION ZD_DrawEllipseToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawEllipseToCtrl" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval TopLeftX as long, _            ' The top X of the rectangular region matching the ellipse size.
  byval TopLeftY as long, _            ' The top Y of the rectangular region matching the ellipse size.
  byval BottomRightX as long, _        ' The bottom X of the rectangular region matching the ellipse size.
  byval BottomRightY as long, _        ' The bottom Y of the rectangular region matching the ellipse size.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval OutlineSize as long, _         ' Size of the outline.
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE (see below).
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  ) as long
' The ellipse coordinates must match a rectangualr perimeter
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect
'
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' Create CURVE overlay object.
' Version 1.14
' Each overlay object must have a unique identifier.
  DECLARE FUNCTION ZD_DrawCurveToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawCurveToCtrl" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval pXY AS ZPOINTS PTR, _          ' Pointer to an ARRAY of POINTS (holding x,y coordinates of each point).
  byval ArraySize as long, _           ' UBOUND - LBOUND + 1 = number of point in the array.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval CurveSize as long, _           ' Size of the curve.
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE (see below).
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect
' %ZD_DRAW_OPEN                          Do not apply to rectangle
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' Create POLYLINE overlay object.
' Version 1.14
' Each overlay object must have a unique identifier.
  DECLARE FUNCTION ZD_DrawPolyLineToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawPolyLineToCtrl" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval pXY AS ZPOINTS PTR, _          ' Pointer to an ARRAY of POINTS (holding x,y coordinates of each point).
  byval ArraySize as long, _           ' UBOUND - LBOUND + 1 = number of point in the array.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval CurveSize as long, _           ' Size of the polyline.
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE (see below).
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect
' %ZD_DRAW_OPEN                          Do not apply to rectangle
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Process pending window or dialog messages during animation sequence.
  DECLARE FUNCTION ZD_DoEvents LIB "GDIMAGE.DLL" ALIAS "ZD_DoEvents" () as long
' Return:
' %WM_QUIT if user presses on exit button else %NULL.
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' To show or hide a GDImage overlay object
  DECLARE SUB ZD_ShowObject LIB "GDIMAGE.DLL" ALIAS "ZD_ShowObject" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ShowOrHide as long _           ' %TRUE = SHOW, %FALSE = HIDE.
  )
' Apply to any of the ZD_DrawXXXToCtrl functions.
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Check for visibility of a GDImage overlay object
  DECLARE FUNCTION ZD_IsObjectVisible LIB "GDIMAGE.DLL" ALIAS "ZD_IsObjectVisible" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long
' Return:
' TRUE (-1) if visible, FALSE (0) if not.
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' Get the STYLE of a GDImage overlay object
  DECLARE FUNCTION ZD_GetObjectStyle LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectStyle" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long
' Return:
' The STYLE of the object.
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' Set the STYLE of a GDImage overlay object
  DECLARE SUB ZD_SetObjectStyle LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectStyle" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval UseStyle as long _             ' The new style to use (must be a valid GDImage style).
  )
' See: GDImage overlay Generic STYLE
' Note: Use ZI_UpdateWindow to refresh the display after the style change.
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' To set up the Alpha channel of a specific sprite object
  DECLARE SUB ZD_SetObjectAlpha LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectAlpha" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval Alpha AS BYTE, _               ' The alpha channel (range 0-255, 0 = transparent, 255 = opaque).
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' To get the ARGB parameters of a specific sprite object
  DECLARE SUB ZD_GetObjectARGB LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectARGB" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYREF Alpha AS BYTE, _               ' The alpha channel (range 0-255, 0 = transparent, 255 = opaque).
  BYREF Red AS BYTE, _                 ' The RED component (0-255).
  BYREF Green AS BYTE, _               ' The GREEN component (0-255).
  BYREF Blue AS BYTE _                 ' The BLUE component (0-255).
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' To set the ARGB parameters of a specific sprite object
  DECLARE SUB ZD_SetObjectARGB LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectARGB" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval Alpha AS BYTE, _               ' The alpha channel (range 0-255, 0 = transparent, 255 = opaque).
  byval Red AS BYTE, _                 ' The RED component (0-255).
  byval Green AS BYTE, _               ' The GREEN component (0-255).
  byval Blue AS BYTE _                 ' The BLUE component (0-255).
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Retrieve the immediate parent of the overlay object
  DECLARE FUNCTION ZD_GetObjectParent LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectParent" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long
' Return:
' The GDImage control handle of the parent.
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Retrieve the bounding size that best fit the overlay object region
  DECLARE SUB ZD_GetObjectBound LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectBound" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  BYREF BoundWidth as long, _          ' The bounding with
  BYREF BoundHeight as long _          ' The bounding height
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Retrieve overlay object X, Y coordinates
  DECLARE SUB ZD_GetObjectXY LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectXY" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  BYREF x as long, _                   ' The X coordinate
  BYREF y as long _                    ' The Y coordinate
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Set the X,Y coordinates of an overlay object.
  DECLARE SUB ZD_SetObjectXY LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectXY" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  byval x as long, _                   ' The X coordinate
  byval y as long, _                   ' The Y coordinate
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' To Get the Z-order of an overlay object
  DECLARE FUNCTION ZD_GetObjectZorder LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectZorder" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  ) as long
' Return:
' The overlay object Z-order
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' You can use these constants
  %ZD_ORDER_TOP    = &HFFFFFF          ' Z-order Top
  %ZD_ORDER_BOTTOM = &HFFFF&           ' Z-Order Bottom
' To Set the Z-order of an overlay object
  DECLARE FUNCTION ZD_SetObjectZorder LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectZorder" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  byval SetOrder as long _             ' The new Z-order of the object
  ) as long
' Return:
' 0 = Error
' ELSE the PREVIOUS z-order of the object.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Create a sprite BITMAP (overlay object).
  DECLARE FUNCTION ZD_DrawBitmapToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawBitmapToCtrl" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval x as long, _                   ' The X coordinate.
  byval y as long, _                   ' The Y coordinate.
  byval hBitmap as long, _
  byval ColrARGB as long, _
  byval ObjID as long, _
  byval ZS_STYLE as long _
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.20
' To be used with a bitmap object.
' Retrieve a copy of the entire bitmap for the object IDentifier being used,
' using a 2 dimensions array of the form (x,y) pointing directly to pixel.
' You can use the array coordinates as you would do with a standard DC,
' because pixel 0,0 is at coordinate Array(0,0).
' Once your are done with the array, the bitmap is replaced using ZD_SetBitmapObjectBits.
' (see ZD_SetBitmapObjectBits)
  DECLARE FUNCTION ZD_GetBitmapObjectBits LIB "GDIMAGE.DLL" ALIAS "ZD_GetBitmapObjectBits" ( _
  byval ObjID as long, _                   ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  PixelArray() as long _                   ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  ) as long
' Return:
' Null if error, else success.
'****************************************************************************
'
'****************************************************************************
' Version 1.20
' To be used with a bitmap object.
' Replace a copy of a bitmap that was retrieved as a device-independent bitmap.
' (see ZD_GetBitmapObjectBits)
  DECLARE FUNCTION ZD_SetBitmapObjectBits LIB "GDIMAGE.DLL" ALIAS "ZD_SetBitmapObjectBits" ( _
  byval ObjID as long, _                   ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  PixelArray() as long, _                  ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  OPTIONAL byval DoNotClearArray as long _ ' Boolean flag, %TRUE = DO NOT clear the array.
  )as long
' Return:
' Null if error, else success.
'****************************************************************************
'
'****************************************************************************
' Version 1.21
  TYPE ZPOLYGON
      pXY        as dword    ' 32-bit unsigned POINTS PTR
      ArraySize  AS INTEGER  ' 16-bit signed SHORT integer
      ObjID      as long     ' 32-bit signed LONG integer
      ColorARGB  as long     ' 32-bit signed LONG integer
      PenSize    AS INTEGER  ' 16-bit signed SHORT integer
      ZS_Style   as long     ' 32-bit signed LONG integer
      ZD_Style   as long     ' 32-bit signed LONG integer
  END TYPE
'****************************************************************************
'
'****************************************************************************
' Version 1.21
' Draws a series of closed polygons.
' Each polygon is outlined or filled by using a specific pen size and ARGB color.
' The polygons drawn by this function can overlap.
  DECLARE FUNCTION ZD_PolyPolygon LIB "GDIMAGE.DLL" ALIAS "ZD_PolyPolygon" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  zp() AS ZPOLYGON, _                  ' The polypolygon description.
  byval PolygonCount as long _         ' The plygon count.
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.21
' Show or hide a list of GDImage overlay objects at once.
  DECLARE SUB ZD_ShowObjectList LIB "GDIMAGE.DLL" ALIAS "ZD_ShowObjectList" ( _
  byval ObjectList as long PTR, _     ' A long pointer to an array of object ID
  byval ListSize as long, _           ' The size of the array.
  byval ShowOrHide as long _          ' %TRUE = SHOW, %FALSE = HIDE.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.36
' Show or Hide a specific GDImage overlay object.
  DECLARE SUB ZD_SetObjectVisibility LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectVisibility" ( _
  byval ObjID as long, _      ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ShowOrHide as long _  ' A boolean TRUE/FALSE flag to show or hide the object.
  )
'****************************************************************************
'
'
'****************************************************************************
'****************************************************************************
'*                                                                          *
'*                             HELPER FUNCTIONS                             *
'*                                                                          *
'****************************************************************************
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Retrieve the instance of the current module
  DECLARE FUNCTION zInstance LIB "GDIMAGE.DLL" ALIAS "zInstance" () as long
' Return:
' the instance handle of the running application.
'****************************************************************************
'
'****************************************************************************
' Version 1.07
' Beep the user.
  DECLARE SUB zFocusBeep LIB "GDIMAGE.DLL" ALIAS "zFocusBeep" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.11
' Compute CPU SPEED, handy to compute animation speed.
  DECLARE FUNCTION zGetCPUspeed LIB "GDIMAGE.DLL" ALIAS "zGetCPUspeed" () as long
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Check if file exist
  DECLARE FUNCTION zExist LIB "GDIMAGE.DLL" ALIAS "zExist" ( _
  byval FullPathName AS STRING _ ' The name of the file to check.
  ) as long
' Return:
' TRUE (-1) if exist, FALSE (0) if not.
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' Generic I/O file manager faster and less overhead than built-in PB's functions.
' OPEN File
  DECLARE FUNCTION zFOpen LIB "GDIMAGE.DLL" ALIAS "zFOpen" ( _
  byval FullPathName AS STRING, _ ' The name of the file to open.
  byval AccessMode as long, _
  byval ShareMode as long, _
  BYREF hFile as long _
  ) as long
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' Generic I/O file manager faster and less overhead than built-in PB's functions
' CLOSE File
  DECLARE SUB zFClose LIB "GDIMAGE.DLL" ALIAS "zFClose" ( _
  BYREF hFile as long _
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' Generic I/O file manager faster and less overhead than built-in PB's functions
' GET buffer
  DECLARE FUNCTION zFGet LIB "GDIMAGE.DLL" ALIAS "zFGet" ( _
  byval hFile as long, _
  BYREF sBuffer AS STRING _
  ) as long
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' Generic I/O file manager faster and less overhead than built-in PB's functions
' Disk size of an open file FLOF
  DECLARE FUNCTION zFlof LIB "GDIMAGE.DLL" ALIAS "zFlof" ( _
  byval hFile as long _
  ) as long
'****************************************************************************
'
'****************************************************************************
  MACRO Pi = 3.141592653589793##
  MACRO HalfPI = 1.5707963267948965##
  MACRO PiDiv4 = 0.785398163397448##
  MACRO DegreesToRadians(Deg) = Deg * 0.0174532925199432957##

'****************************************************************************
'
'****************************************************************************

' Version 1.21
' Low level function to retrieve a device-independent bitmap.
  DECLARE FUNCTION zGetDIBits LIB "GDIMAGE.DLL" ALIAS "zGetDIBits" ( _
  byval hBitmap as long, _                 ' A valid bitmap handle.
  PixelArray() as long _                   ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  ) as long

' Version 1.21
' Low level function to replace a copy of a bitmap that was retrieved as a device-independent bitmap.
  DECLARE FUNCTION zSetDIBits LIB "GDIMAGE.DLL" ALIAS "zSetDIBits" ( _
  byval hBitmap as long, _                 ' A valid bitmap handle.
  PixelArray() as long _                   ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  ) as long

' Version 1.30
' Low level function to split an ARGB color.
  DECLARE SUB zSplitColorARGB LIB "GDIMAGE.DLL" ALIAS "zSplitColorARGB" ( _
  byval ARGB as long, _                    ' The ARGB color to split
  Alpha AS BYTE, _                         ' The Alpha channel in the range 0-255.
  Red AS BYTE, _                           ' The Red component in the range 0-255.
  Green AS BYTE, _                         ' The Green component in the range 0-255.
  Blue AS BYTE _                           ' The Blue component in the range 0-255.
  )

'****************************************************************************
'
'****************************************************************************
'****************************************************************************
'***                                                                      ***
'***                         SLIDE SHOW FUNCTIONS                         ***
'***                                                                      ***
'****************************************************************************
'****************************************************************************
' Version 1.25
  TYPE ZSLIDESHOW
    ' Slide section
      FilName   as asciiz * 260
      Delay     as long
      Effect    AS INTEGER
      Grain     AS INTEGER
    ' Font section
      Legend    as asciiz * 128
      FontName  as asciiz * 64
      FontSize  AS INTEGER
      FontColor as long
      Shadow    AS BYTE
      Location  AS BYTE
    ' Background color  // 12-29-2011 version 5.31
      BackColor as long
  END TYPE

  %NM_LASTSLIDE = -23

' Transition effects
  %ZE_EFFECT_MIN                 = 0  '
  %ZE_TRANSLUCENT_SPIRAL         = 0  ' Translucent spiral (uGrain to adjust speed).
  %ZE_SMOOTH_FADING              = 1  ' Smooth fading (uGrain to adjust speed).
  %ZE_MOVE_BOTTOM_TO_TOP         = 2  ' Moving from bottom to top (uGrain to adjust speed).
  %ZE_VERTICAL_LINE              = 3  ' Vertical line (use uGrain to change space between lines).
  %ZE_VERTICAL_LINE_FILLED_RIGHT = 4  ' Vertical line (use uGrain to change space between lines).
  %ZE_CHECKER_BOARD              = 5  ' Checker board (use uGrain for larger square).
  %ZE_RANDOM_DOT                 = 6  ' Random dots (use uGrain for larger dots).
  %ZE_WIPE_TO_CENTER             = 7  ' Wipe to center (uGrain to adjust speed).
  %ZE_STRETCH_FROM_CENTER        = 8  ' Stretch from center (uGrain to adjust speed).
  %ZE_PUSH_LEFT_TO_RIGHT         = 9  ' Push from left to right (uGrain to adjust speed).
  %ZE_PUSH_TOP_TO_BOTTOM         = 10 ' Push from top to bottom (uGrain to adjust speed).
  %ZE_NO_EFFECT                  = 11 ' Cut mode (no transition effect).
  %ZE_EFFECT_MAX                 = 11

' Legend location
  %ZE_TXT_TOP_LEFT               = 1  ' Text on the top, left justified.
  %ZE_TXT_TOP_CENTER             = 2  ' Text on the top, centered.
  %ZE_TXT_TOP_RIGHT              = 3  ' Text on the top, right justified.
  %ZE_TXT_MIDDLE_CENTER          = 4  ' Text on the middle, centered.
  %ZE_TXT_BOTTOM_LEFT            = 5  ' Text on the bottom, left justified.
  %ZE_TXT_BOTTOM_CENTER          = 0  ' Text on the bottom, centered.
  %ZE_TXT_BOTTOM_RIGHT           = 6  ' Text on the bottom, right justified.

'****************************************************************************
'
'****************************************************************************
' Version 1.37
' Start playing a GDImage slide show.
  DECLARE SUB ZI_SlideAnimate LIB "GDIMAGE.DLL" ALIAS "ZI_SlideAnimate" ( _
  byval hGDImageCtrl as long, _  ' The GDImage control handle.
  byval ipt AS ZSLIDESHOW PTR, _ ' A DWORD PTR to a ZSLIDESHOWE array.
  byval ImageCount as long, _    ' Number of element in the array
  byval LoopMode as long _       ' Boolean flag, TRUE = play slide show in loop mode.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' STOP a playing GDImage slide show.
  DECLARE SUB ZI_SlideStop LIB "GDIMAGE.DLL" ALIAS "ZI_SlideStop" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' Play a GDImage slide show in incremental order.
  DECLARE SUB ZI_SlidePlayIncrOrder LIB "GDIMAGE.DLL" ALIAS "ZI_SlidePlayIncrOrder" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' Play a GDImage slide show in decremental order.
  DECLARE SUB ZI_SlidePlayDecrOrder LIB "GDIMAGE.DLL" ALIAS "ZI_SlidePlayDecrOrder" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' PLAY a GDImage slide show that has been previously PAUSED.
  DECLARE SUB ZI_SlidePlay LIB "GDIMAGE.DLL" ALIAS "ZI_SlidePlay" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' PAUSE a playing GDImage slide show.
  DECLARE SUB ZI_SlidePause LIB "GDIMAGE.DLL" ALIAS "ZI_SlidePause" ()
'****************************************************************************
'
'****************************************************************************
'****************************************************************************
'*                                                                          *
'*                             OpenGL FUNCTIONS                             *
'*                                                                          *
'****************************************************************************
'****************************************************************************
'
'****************************************************************************
  %ZI_GLDC      = 8  ' OpenGL Device Context
  %ZI_GLRC      = 9  ' OpenGL Rendering Context
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' No need to use it if you have already registered the RegisterGDImageClass
' -------------------------------------------------------------------------
' Must be done in the WinMain section BEFORE USING any of the GDImage function.
' Parameter: None
  DECLARE FUNCTION RegisterGLImageClass LIB "GDIMAGE.DLL" ALIAS "RegisterGLImageClass" () as long
' Return:
' 0 = means failure, any other value means registered.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Create an OpenGL texture from any of the supported GDImage graphic format.
' GDImage takes care of all the hard stuff to create a correct OpenGL texture.
  DECLARE FUNCTION ZI_CreateGLTextureFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_CreateGLTextureFromFile" ( _
  zFullPathName as asciiz, _        ' Name of the graphic file to create the texture from.
  xPower2 as long, _                ' A value in the range: 2, 4, 16, 32, 64, 128, 256, 512, etc.
  yPower2 as long, _                ' A value in the range: 2, 4, 16, 32, 64, 128, 256, 512, etc.
  PixelArray() AS BYTE _           ' Byte array holding the texture.
  ) as long
' Return:
' If the function succeeds the returned value is %TRUE,
' and the PixelArray is full of bytes that are already converted to the internal RGBA OpenGL format.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Create on the fly an OpenGL texture from any supported GDImage raster graphic file.
  DECLARE FUNCTION ZI_SetGLTextureFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_SetGLTextureFromFile" ( _
  zFullPathName as asciiz _        ' Name of the graphic file to create the texture from.
  ) as long
' Return:
' An OpenGL error code in case of Error.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Enable the use of OpenGL with a previously "bounded" GDImage OpenGL texture.
  DECLARE SUB ZI_InitGLControl LIB "GDIMAGE.DLL" ALIAS "ZI_InitGLControl" ( _
  byval ARGB as long _ ' The GDImage ARGB color to paint the control background.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Allows you to resize the "view port" of a GDImage OpenGL control during WM_SIZE message.
' The GDImage control being the container of the OpenGL "view port",
' you must resize both the control and the "veiw port".
  DECLARE SUB ZI_ResizeGLWindow LIB "GDIMAGE.DLL" ALIAS "ZI_ResizeGLWindow" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  )
' Note: To resize automatically a GDImage control use the ZI_SetAnchorMode API.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Allows you to update a GDImage OpenGL control.
  DECLARE SUB ZI_UpdateGLWindow LIB "GDIMAGE.DLL" ALIAS "ZI_UpdateGLWindow" (byval hWnd as long)
' Note:
' This API must be called from your "DrawScene" procedure to display the rendered animation.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' To retrieve the GDImage OpenGL permanent (CS_OWNDC) Device Context.
  DECLARE FUNCTION ZI_GetGLDC LIB "GDIMAGE.DLL" ALIAS "ZI_GetGLDC" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Do not delete this DC.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' To retrieve the GDImage OpenGL Rendering Context.
  DECLARE FUNCTION ZI_GetGLRC LIB "GDIMAGE.DLL" ALIAS "ZI_GetGLRC" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
'****************************************************************************
'
'****************************************************************************
' Version 1.31
  TYPE ZGLFONT
      fontName   as asciiz * 64 ' The True Type font name.
      fontBase   as long        ' The OpenGL FontBase (do not set this).
      charStart  as long        ' OpenGL starting ASCII character (usually 32).
      charNum    as long        ' OpenGL number of glyphe characters to create(usually 96).
      fontHeight as long        ' The font size (72 DPI).
      fontWeight as long        ' The font weigt.
      fontHandle as long        ' The Win32 font handle
  END TYPE
'****************************************************************************
'
'****************************************************************************
' Version 1.31
' Create an OpenGL font, from a Windows True Type Font, to use with ZI_DrawGLText.
  DECLARE SUB ZI_BuildGLfont LIB "GDIMAGE.DLL" ALIAS "ZI_BuildGLfont" ( _
  byval hGLcontrolDC as long, _ ' The GDimage Device Context (see ZI_GetGLDC).
  UseFont AS ZGLFONT _          ' Pointer to a ZGLFONT structure.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.31
' Delete a GDImage OpenGL font previously created with ZI_BuildGLfont.
  DECLARE SUB ZI_DeleteGLFont LIB "GDIMAGE.DLL" ALIAS "ZI_DeleteGLFont" ( _
  UseFont AS ZGLFONT _          ' Pointer to a ZGLFONT structure.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.31
' Display a text string on a GDImage OpenGL graphic control.
  DECLARE SUB ZI_DrawGLText LIB "GDIMAGE.DLL" ALIAS "ZI_DrawGLText" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  UseFont AS ZGLFONT, _         ' Pointer to a ZGLFONT structure.
  byval x as long, _            ' The X location in pixel coordinates.
  byval y as long, _            ' The Y location in pixel coordinates.
  zTxt as asciiz, _             ' The text string to display.
  byval ARGB as long _          ' The ARGB color to use.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.32
' Return Width and Height of a string based on a specific ZGLFONT font structure.
  DECLARE SUB ZI_GetGLTextExtent LIB "GDIMAGE.DLL" ALIAS "ZI_GetGLTextExtent"( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  UseFont AS ZGLFONT, _         ' Pointer to a ZGLFONT structure.
  zTxt as asciiz, _             ' The text string to compute the size from.
  stWidth as long, _            ' The width of the string in pixel.
  stHeight as long _            ' The height of the string in pixel.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.31
' Do not create a default SQUARE shape texture.
' With spherical objects, it is better to use a rectangular texture:
' Best size would be 128 x 64, 256 x 128, 512 x 256, 1024 x 512, etc. (always 2^n).
  DECLARE SUB ZI_DoNotSquareTexture LIB "GDIMAGE.DLL" ALIAS "ZI_DoNotSquareTexture" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.31
' Set the current GDImage OpenGL zoom.
  DECLARE SUB ZI_SetGLzoom LIB "GDIMAGE.DLL" ALIAS "ZI_SetGLzoom" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval fovy as long _          ' The field of view angle, in degrees (1-180), in the y-direction.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.31
' Retrieve the current GDImage OpenGL zoom.
  DECLARE FUNCTION ZI_GetGLzoom LIB "GDIMAGE.DLL" ALIAS "ZI_GetGLzoom" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Return:
' The fovy angle in degree from the observer in the range 1-180.
'****************************************************************************
'
'****************************************************************************
' Version 1.31
' Create a polar view.
  DECLARE SUB ZI_UseGLPolarView LIB "GDIMAGE.DLL" ALIAS "ZI_UseGLPolarView" ( _
  byval radius AS DOUBLE, _     ' The radius value.
  byval twist AS DOUBLE, _      ' The twist value.
  byval latitude AS DOUBLE, _   ' The latitude value.
  byval longitude AS DOUBLE _   ' The longitude value.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.33
' Convert a GDImage ARGB color to an OpenGL color.
' The new color applies to all subsequent OpenGL drawing procedures until a new color is defined.
  DECLARE SUB ZI_glColor4f LIB "GDIMAGE.DLL" ALIAS "ZI_glColor4f" ( _
  byval ARGB as long _          ' A GDImage ARGB color.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.32
' Determines whether a key is up or down at the time the function is called.
  DECLARE FUNCTION ZI_IsKeyDown LIB "GDIMAGE.DLL" ALIAS "ZI_IsKeyDown" ( _
  byval CheckKey as long _ ' One of 256 possible virtual-key codes.
  ) as long
' Return:
' TRUE = the key is down, FALSE = the key is up.
'****************************************************************************
'
'****************************************************************************
' Version 1.32
' Determines whether the left mouse button is up or down at the time the function is called.
  DECLARE FUNCTION ZI_IsLButtonDown LIB "GDIMAGE.DLL" ALIAS "ZI_IsLButtonDown" () as long
' Return:
' TRUE = the mouse button is down, FALSE = the mouse button is up.
'****************************************************************************
'
'****************************************************************************
' Version 1.32
' Determines whether the right mouse button is up or down at the time the function is called.
  DECLARE FUNCTION ZI_IsRButtonDown LIB "GDIMAGE.DLL" ALIAS "ZI_IsRButtonDown" () as long
' Return:
' TRUE = the mouse button is down, FALSE = the mouse button is up.
'****************************************************************************
'
'****************************************************************************
' Version 1.32
' Determines whether a the Shift key is up or down at the time the function is called.
  DECLARE FUNCTION ZI_IsShiftKeyPressed LIB "GDIMAGE.DLL" ALIAS "ZI_IsShiftKeyPressed" () as long
' Return:
' TRUE = the Shift key is down, FALSE = the Shift key is up.
'****************************************************************************
'
'****************************************************************************
' Version 1.32
' Determines whether the Ctrl key is up or down at the time the function is called.
  DECLARE FUNCTION ZI_IsCtrlKeyPressed LIB "GDIMAGE.DLL" ALIAS "ZI_IsCtrlKeyPressed" () as long
' Return:
' TRUE = the Ctrl key is down, FALSE = the Ctrl key is up.
'****************************************************************************
'
'****************************************************************************
' Version 1.34
' Create a GDImage OpenGL panorama view.
  DECLARE SUB ZI_UseGLPanoramaView LIB "GDIMAGE.DLL" ALIAS "ZI_UseGLPanoramaView" ( _
  byval Vert AS DOUBLE, _  ' The vertical orientation angle in degree.
  byval Horz AS DOUBLE _   ' The horizontal orientation angle in degree.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.35
  TYPE ZGLTEXTURE
      ID       as long
      FullName as asciiz * 260
      Texture  as long
  END TYPE
'****************************************************************************
'
'****************************************************************************
' Version 1.35
' Load multiple OpenGL "Named texture" at once.
  DECLARE FUNCTION ZI_SetMutipleGLTextureFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_SetMutipleGLTextureFromFile" ( _
  byval ztp AS ZGLTEXTURE PTR, _         ' A DWORD PTR to a ZGLTEXTURE array.
  byval N as long _                      ' Number of element in the array
  ) as long
' Return:
' An OpenGL error code in case of Error.
'****************************************************************************
'
'****************************************************************************
' Version 1.35
' Assign a new texture to an existing OpenGL "Named texture".
  DECLARE FUNCTION ZI_UpdateNamedGLTextureFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_UpdateNamedGLTextureFromFile" ( _
  zFullName as asciiz, _       ' Full qualified path name.
  byval NamedTexture as long _ ' An existing OpenGL NamedTexture
  ) as long
' Return:
' An OpenGL error code in case of Error.
'****************************************************************************
'
'****************************************************************************

  %WM_MMTIMER = &H400 + 2060 ' MultiMedia timer message

  MACRO GLenum     = DWORD   ' 32-Bit unsigned.
  MACRO GLboolean  = BYTE    ' 8-Bit  unsigned.
  MACRO GLbitfield = DWORD   ' 32-Bit unsigned.
  MACRO GLbyte     = BYTE    ' 8-Bit  signed.
  MACRO GLshort    = INTEGER ' 16-Bit signed.
  MACRO GLint      = LONG    ' 32-Bit signed.
  MACRO GLubyte    = BYTE    ' 8-Bit  unsigned.
  MACRO GLushort   = WORD    ' 16-Bit unsigned.
  MACRO GLuint     = DWORD   ' 32-Bit unsigned.
  MACRO GLsizei    = LONG    ' 32-Bit signed.
  MACRO GLfloat    = SINGLE  ' single precision float.
  MACRO GLclampf   = SINGLE  ' single precision float in [0,1].
  MACRO GLdouble   = DOUBLE  ' double precision float.
  MACRO GLclampd   = DOUBLE  ' double precision float in [0,1].
  MACRO GLvoid     = ANY     ' No need for it.


'****************************************************************************
'
'****************************************************************************
' Version 1.39
' FlipReverse :
  %ZD_Normal  = 0 ' Orientation unchanged (default)
  %ZD_Flip    = 1 ' Swap top / bottom
  %ZD_Reverse = 2 ' Swap left / right
' Allows you to crop / create a new bitmap from an existing one using new coordinates that must lie within the range of the previous one.
  DECLARE FUNCTION ZI_CropBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_CropBitmap" ( _
  byval hBmp as long, _          ' Handle to an existing bitmap.
  byval x as long, _             ' X top left corner of the croping section.
  byval y as long, _             ' Y top corner of the croping section.
  byval w as long, _             ' Width of the crop.
  byval h as long, _             ' Height of the crop.
  byval FlipReverse as long _    ' Orientation of the resulting croped section.
  ) as long
'****************************************************************************
'
'****************************************************************************
' Version 3.01 '// 1.39
' Save multiple layers into a  single disk file, using any of the supported graphic format.
  %RotateNoneFlipNone = 0
  %Rotate90FlipNone = 1
  %Rotate180FlipNone = 2
  %Rotate270FlipNone = 3
  DECLARE FUNCTION ZI_RenderLayersToFile LIB "GDIMAGE.DLL" ALIAS "ZI_RenderLayersToFile" ( _
  byval hGDImageCtrl as long, _      ' The GDimage control handle.
  zFullName as asciiz, _             ' Full qualified path name.
  byval Quality as long, _           ' For JPEG only, quality ranges from 0-100 (100 = best quality)
  byval Rotation as long, _          ' Orientation
  OPTIONAL byval UseWidth as long, _ ' Optional parameter to fit the image into a specific width.
  OPTIONAL byval UseHeight as long _ ' Optional parameter to fit the image into a specific height.
  ) as long
'****************************************************************************
'
'****************************************************************************
' Version 1.39
' Replace a RGB color with another RGB color, using a bitmap handle.
  DECLARE SUB ZI_ReplaceRGBColorBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_ReplaceRGBColorBitmap" ( _
  byval hBitmap as long, _      ' A valid bitmap handle.
  byval WasColor as long, _     ' RGB Pixel color to replace
  byval NewColor as long _      ' New RGB pixel color
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.41
' Change the zooming value of a GDImage Zoom window control ( ZI_ZoomWindow property).
  DECLARE SUB ZI_SetZoomValue LIB "GDIMAGE.DLL" ALIAS "ZI_SetZoomValue"( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval ZoomValue AS SINGLE _   ' The zoom factor as a floating value.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.41
' Get the zoom factor of a GDImage Zoom window control ( ZI_ZoomWindow property).
  DECLARE FUNCTION ZI_GetZoomValue LIB "GDIMAGE.DLL" ALIAS "ZI_GetZoomValue" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) AS SINGLE
' Return:
' The zoom factor as a floating value
'****************************************************************************
'
'****************************************************************************
' Version 1.41
' Computes location and size to stretch a bitmap preserving its aspect.
  DECLARE SUB ZI_Iconise LIB "GDIMAGE.DLL" ALIAS "ZI_Iconise" ( _
  byval xPicSize as long, _ ' The real image width.
  byval yPicSize as long, _ ' The real image height.
  byval xCell as long, _    ' The fit into wdith.
  byval yCell as long, _    ' The fit inot height.
  BYREF xPos as long, _     ' New X computed value.
  BYREF yPos as long, _     ' New Y computed value.
  BYREF xSize as long, _    ' New Width computed value.
  BYREF ySize as long _     ' New Height computed value.
  )

  %WM_USER          = 1024
  %ZM_Size          = %WM_USER + 1001
  %ZM_Crop          = %WM_USER + 1002
  %ZM_CENTER_DIALOG = %WM_USER + 1003
  %ZM_CropRedEye    = %WM_USER + 1004
'****************************************************************************
'
'****************************************************************************
' Version 1.41
' Retrieve the current selected bitmap from a specific Device Context.
  DECLARE FUNCTION ZI_GetBitmapFromDC LIB "GDIMAGE.DLL" ALIAS "ZI_GetBitmapFromDC" ( _
  byval hDC as long _ ' A Windows valid DC
  ) as long
' Return:
' The bitmap handle matching the specific DC if any.
'****************************************************************************
'
'****************************************************************************
' Version 1.41
' Enhanced HALFTONE StretchBlt function
  DECLARE FUNCTION ZD_StretchBlt LIB "GDIMAGE.DLL" ALIAS "ZD_StretchBlt" ( _
  byval hDCdest as long, _    ' Handle to destination DC.
  byval xDest as long, _      ' X-coord of destination upper-left corner.
  byval yDest as long, _      ' Y-coord of destination upper-left corner.
  byval DestWidth as long, _  ' Width of destination rectangle.
  byval DestHeight as long, _ ' Height of destination rectangle.
  byval hDCsrce as long, _    ' Handle to source DC.
  byval xSrce as long, _      ' X-coord of source upper-left corner.
  byval ySrce as long, _      ' Y-coord of source upper-left corner.
  byval SrceWidth as long, _  ' Width of source rectangle.
  byval SrceHeight as long _  ' Height of source rectangle.
  ) as long
'****************************************************************************
'
'****************************************************************************
' Version 1.41
' Split multiple parts of a full path name.
  DECLARE SUB zSplitN LIB "GDIMAGE.DLL" ALIAS "zSplitN" ( _
  byval FullName AS STRING,  _
  PathName AS STRING, _
  FilName AS STRING _
  )
' Return:
' The qualified path name plus the single file name.
'****************************************************************************
'
'****************************************************************************
' Version 1.41
' Load image from file and return a valid GDIPLUS image handle
  DECLARE FUNCTION zLoadImageFromFile LIB "GDIMAGE.DLL" ALIAS "zLoadImageFromFile" ( _
  zFullName as asciiz, _      ' Full path name to any of the supported graphic format.
  BYREF imgW as long, _       ' Return the image width.
  BYREF imgH as long, _       ' Return the image height.
  byval Orientation as long _ ' Orientation to create the memory image.
  ) as long
' Return:
' A valid GDIPLUS image handle, suitable with the low level GDIPLUS flat API.
'****************************************************************************
'
'****************************************************************************
' Version 1.41
' Save image to file using a valid GDIPLUS image handle.
  DECLARE FUNCTION zSaveImageToFile LIB "GDIMAGE.DLL" ALIAS "zSaveImageToFile" ( _
  zFullName as asciiz, _      ' Full path name destination.
  byval Img as long, _        ' A valid GDIPLUS handle.
  byval Quality as long _     ' Quality applies to the JPEG format only.
  ) as long
' Return:
' Null in case of success, else a GDIPLUS error code.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Assign a label to any sprite object.
  DECLARE SUB ZD_SetObjectImageLabel LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectImageLabel" ( _
  byval ObjID as long, _  ' The unique sprite object identifier.
  zUseText as asciiz _    ' The label to use.
  )
' Comment:
' This label is a complement to the unique identifier being used for a sprite.
' It can be used to dialog with the user when using a ZI_EventMessage callback.
' Remark:
' Maximum label size is 64 characters.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the label matching a specific sprite object identifier.
  DECLARE FUNCTION ZD_GetObjectImageLabel LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectImageLabel" ( _
  byval ObjID as long _  ' The unique sprite object identifier.
  ) AS STRING
' Return:
' The label matching the identifier if any.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Setup the scroll with background property of a specific sprite object.
  DECLARE SUB ZD_SetObjectScroll LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectScroll" ( _
  byval ObjID as long, _     ' The unique sprite object identifier.
  byval TrueFalse as long _  ' The TRUE or FALSE scroll mode.
  )
' Remark:
' If scroll mode is set to false (default),
' then the sprite looks floating above the backround when you scroll it.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the scroll status of a specific sprite object identifier.
  DECLARE FUNCTION ZD_GetObjectScroll LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectScroll" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' Null = scrolling disabled, Else = scrolling enabled.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Set the mouse lock status of a specific sprite object.
  DECLARE SUB ZD_SetObjectLocked LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectLocked" ( _
  byval ObjID as long, _     ' The unique sprite object identifier.
  byval TrueFalse as long _  ' The TRUE or FALSE lock mode.
  )
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the mouse lock status of a specific sprite object identifier.
  DECLARE FUNCTION ZD_GetObjectLocked LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectLocked" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Use full variable opacity with 32-bit PNG transparent.
  DECLARE SUB ZD_UsePngOpacity LIB "GDIMAGE.DLL" ALIAS "ZD_UsePngOpacity" ( _
  byval ObjID as long, _     ' The unique sprite object identifier.
  byval TrueFalse as long _  ' TRUE = enable, FALSE = disable (default).
  )
' Remark:
' This feature is only available with PNG 32-bit, because they have an alpha channel.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' To customize the default Load / Save Dialog messages.
  DECLARE SUB ZI_SetSaveDialogMsg LIB "GDIMAGE.DLL" ALIAS "ZI_SetSaveDialogMsg" ( _
  zCaptionLoad as asciiz, _ ' Caption for the Load dialog.
  zCaptionSave as asciiz, _ ' caption for the Save dialog.
  zDefaultName as asciiz _  ' Default file name for the Save dialog.
  )
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Monitor the Windows message flow using a callback to take control over the GDImage default procedure.
  DECLARE SUB ZI_EventMessage LIB "GDIMAGE.DLL" ALIAS "ZI_EventMessage" ( _
  byval pCodePtr as dword, _   ' Pointer to a MyCallback function (see remark below).
  byval WM_Message as long, _  ' The Windows message to filter.
  byval SetReset as long _     ' TRUE = enable, FALSE = disable callback for the specific message.
  )

' Remark:
' FUNCTION MyCallBack( _       ' Use any name, and provide its code pointer to ZI_EventMessage
' byval hWnd as long, _        ' The GDImage control handle sending the event.
' byval Msg as long, _         ' Any standard Windows message.
' byval wParam as long, _      ' The contents of this parameter depend on the value of the Msg parameter.
' byval lParam as long _       ' The contents of this parameter depend on the value of the Msg parameter.
' ) as long                    ' See MSDN documentation about using a WindowProc function.
'
' Important:
' If you want to stop further processing of the message by GDImage, then the callback function must return TRUE.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the unique object IDentifier of the sprite that has the GDImage focus.
' Its primary purpose it to be used from a ZI_EventMessage callback.
  DECLARE FUNCTION ZI_GetObjectFocusID LIB "GDIMAGE.DLL" ALIAS "ZI_GetObjectFocusID" () as long
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the unique object IDentifier of the sprite hover the mouse.
' Its primary purpose it to be used from a ZI_EventMessage callback.
  DECLARE FUNCTION ZI_MouseOverObjectID LIB "GDIMAGE.DLL" ALIAS "ZI_MouseOverObjectID" () as long
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the GDImage mouse captured X,Y location.
' Its primary purpose it to be used from a ZI_EventMessage callback.
  DECLARE SUB ZD_GetObjectXYcapture LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectXYcapture" ( _
  byval ObjID as long, _  ' The unique sprite object identifier.
  BYREF x as long, _      ' Return the mouse X cursor location.
  BYREF y as long _       ' Return the mouse Y cursor location.
  )
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the Item of the sprite being moved.
' Its primary purpose it to be used from a ZI_EventMessage callback.
  DECLARE FUNCTION ZI_GetMovingSpriteItem LIB "GDIMAGE.DLL" ALIAS "ZI_GetMovingSpriteItem" () as long
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the unique IDentifier of the sprite being moved.
' Its primary purpose it to be used from a ZI_EventMessage callback.
  DECLARE FUNCTION ZI_GetMovingSpriteID LIB "GDIMAGE.DLL" ALIAS "ZI_GetMovingSpriteID" () as long
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Retrieve the DIB bitmap handle of the GDImage control background.
  DECLARE FUNCTION ZI_GetBMP LIB "GDIMAGE.DLL" ALIAS "ZI_GetBMP" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Create an OpenGL transparent texture from 32-bit PNG using variable opacity.
' GDImage takes care of all the hard stuff to create a correct OpenGL texture.
  DECLARE FUNCTION ZI_CreateGLTextureFrom32Bit LIB "GDIMAGE.DLL" ALIAS "ZI_CreateGLTextureFrom32Bit" ( _
  zFullPathName as asciiz, _        ' Name of the graphic file to create the texture from.
  xPower2 as long, _                ' A value in the range: 2, 4, 16, 32, 64, 128, 256, 512, etc.
  yPower2 as long, _                ' A value in the range: 2, 4, 16, 32, 64, 128, 256, 512, etc.
  PixelArray() AS BYTE _            ' Byte array holding the texture.
  ) as long
' Remark:
' It can also be used to create opaque texture from a file without alpha channel.
' Return:
' If the function succeeds the returned value is %TRUE,
' and the PixelArray is full of bytes that are already converted to the internal RGBA OpenGL format.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Create on the fly an OpenGL transparent texture from a PNG 32-bit using variable opacity.
  DECLARE FUNCTION ZI_SetGLTextureFrom32Bit LIB "GDIMAGE.DLL" ALIAS "ZI_SetGLTextureFrom32Bit" ( _
  zFullPathName as asciiz _        ' Name of the graphic file to create the texture from.
  ) as long
' Return:
' An OpenGL error code in case of Error.
'****************************************************************************
'
'****************************************************************************
' Version 2.00
' Load multiple OpenGL transparent "Named texture" at once from PNG 32-bit using variable opacity.
  DECLARE FUNCTION ZI_SetMutipleGLTextureFrom32Bit LIB "GDIMAGE.DLL" ALIAS "ZI_SetMutipleGLTextureFrom32Bit" ( _
  byval ztp AS ZGLTEXTURE PTR, _         ' A DWORD PTR to a ZGLTEXTURE array.
  byval N as long _                      ' Number of element in the array
  ) as long
' Return:
' An OpenGL error code in case of Error.

' Version 2.00
  DECLARE FUNCTION ZI_FitImageFrom32Bit LIB "GDIMAGE.DLL" ALIAS "ZI_FitImageFrom32Bit" ( _
  zFullPath as asciiz, _
  byval Xin as long, _
  byval Yin as long _
  ) as long

' Version 2.01
' To force the default folder being used by ZI_LoadDialog
  DECLARE FUNCTION ZI_LoadSavePath LIB "GDIMAGE.DLL" ALIAS "ZI_LoadSavePath" ( _
  zUseThisPath as asciiz, _              ' The new folder path
  byval SetGet as long _                 ' The Set/Get boolean property: Set = 1, Get = 0.
  ) AS STRING
' Return:
' The folder path when SetGet is in Get mode.

' Version 2.02 is DotNET compatible.

'****************************************************************************
'
'****************************************************************************
' Version 2.07
' Create a valid GDI BITMAP handle from FILE using any of the supported GDImage format,
' and using a mirror reflection effect.
  DECLARE FUNCTION ZI_CreateMirrorBitmapFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_CreateMirrorBitmapFromFile" ( _
  zFullImagePath as asciiz, _      ' The name of an image file.
  BitmapWidth as long, _           ' The width of the bitmap.
  BitmapHeight as long _           ' The Height of the bitmap.
  ) as long
' Return:
' A valid GDI bitmap handle (do not confuse GDI bitmap handle and GDI+ Image handle).
' Important:
' You must use DeleteObject(GDIBitmapHandle) when you do not need it anymore.
'****************************************************************************
'
'****************************************************************************
' Version 2.09
' Twin any GDImage object (sprite bitmap, text, vector object)
' The duplicated object will have exactly the same parameters as the original except for the x, y location.
  DECLARE FUNCTION ZD_TwinObject LIB "GDIMAGE.DLL" ALIAS "ZD_TwinObject" ( _
  byval IDtoTwin as long, _       ' The unique IDentifier of the object to duplicate.
  byval TwinID as long, _         ' The unique IDentifier of the new Twin object.
  byval x as long, _              ' The X location in pixel coordinates.
  byval y as long _               ' The Y location in pixel coordinates.
  ) as long
' Important:
' The duplicated object will have exactly the same parameters as the original except for the x, y location.
' However it uses a distinct Font handle for OBJECT_TEXT and a distinct Bitmap handle for OBJECT_IMAGE.
'****************************************************************************
'
'****************************************************************************
' Version 2.10
' Clone any GDImage object (sprite bitmap, text, vector object)
  DECLARE FUNCTION ZD_CloneObject LIB "GDIMAGE.DLL" ALIAS "ZD_CloneObject" ( _
  byval IDtoClone as long, _      ' The unique IDentifier of the object to duplicate.
  byval CloneID as long, _        ' The unique IDentifier of the new Twin object.
  byval x as long, _              ' The X location in pixel coordinates.
  byval y as long _               ' The Y location in pixel coordinates.
  ) as long
' Important:
' The clone shares the same handles and parameters than the original, except for the x, y location.
' It it doesn't create a distinct Font handle for OBJECT_TEXT, nor a distinct Bitmap handle for OBJECT_IMAGE.
'****************************************************************************
'
'****************************************************************************
' Version 2.10
' Delete any GDImage object (sprite bitmap, text, vector object)
  DECLARE SUB ZD_DeleteObject LIB "GDIMAGE.DLL" ALIAS "ZD_DeleteObject" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  )
'****************************************************************************
'
'****************************************************************************
' Version 2.10
' Apply a scale factor to resize a sprite on the fly
  DECLARE SUB ZD_SetObjectScale LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectScale" ( _
  byval ObjID as long, _       ' The unique sprite object identifier.
  byval ScaleValue AS SINGLE _ ' The scale factor 0.5, 0.75, 0.80, etc.
  )
' Note:
' The real size of the sprite bitmap stay unchanged, it just affect the way it is being shown.
'****************************************************************************
'
'****************************************************************************
' Version 2.10
' Get the scale factor for the specific sprite identifier
  DECLARE FUNCTION ZD_GetObjectScale LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectScale" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) AS SINGLE
' Return:
' The current scale factor (default = 1, means no scale factor).
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Delete all objects matching a specific GDImage control
  DECLARE SUB ZI_DeleteCtrlObject LIB "GDIMAGE.DLL" ALIAS "ZI_DeleteCtrlObject" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Associate a new memory bitmap matching the client size of the GDImage control
' to be used as a private DC.
  DECLARE SUB ZI_SetCtrlEmptyBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_SetCtrlEmptyBitmap" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval RGBcolor as long _      ' The RGB color to paint the memory bitmap background.
  )
' Note:
' The size of the memory bitmap will match exactly the client size of the GDImage control.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Get the horizontal scroll range for a specific GDImage control
  DECLARE FUNCTION ZI_GetXscroll LIB "GDIMAGE.DLL" ALIAS "ZI_GetXscroll" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Return:
' The horizontal scroll range in pixel.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Get the vertical scroll range for a specific GDImage control
  DECLARE FUNCTION ZI_GetYscroll LIB "GDIMAGE.DLL" ALIAS "ZI_GetYscroll" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Return:
' The verical scroll range in pixel.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Enable/disable the keyboard hook being used to move the sprite with the direction keys.
  DECLARE FUNCTION ZI_DisableKeybHook LIB "GDIMAGE.DLL" ALIAS "ZI_DisableKeybHook" ( _
  byval EnableDisable as long, _ ' TRUE = Disable, FALSE = Enable
  byval RW as long _             ' TRUE = Set EnableDisable value, FALSE = Read EnableDisable value
  ) as long
' Remark:
' Do it only once per session from the main program section.
' Return:
' The current status.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
  %OBJECT_TEXT        = 1
  %OBJECT_ELLIPSE     = 2
  %OBJECT_RECT        = 3
  %OBJECT_CURVE       = 4
  %OBJECT_ARROW       = 5
  %OBJECT_POLYLINE    = 6
  %OBJECT_BITMAP      = 7
  %OBJECT_BEZIER      = 8
  %OBJECT_POLYPOLYGON = 9
  %OBJECT_TEXTBITMAP  = 10

' Retrieve the type of a GDImage sprite object.
  DECLARE FUNCTION ZD_GetObjectType LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectType" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' The object type

' Change the type of a GDImage sprite object.
  DECLARE SUB ZD_SetObjectType LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectType" ( _
  byval ObjID as long, _       ' The unique sprite object identifier.
  byval ObjectType as long _   ' The object type (see ZD_GetObjectType)
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Retrieve the rotation angle of a GDImage sprite object.
  DECLARE FUNCTION ZD_GetObjectAngle LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectAngle" ( _
  byval ObjID as long _
  ) as long
' Return:
' The rotation angle in degree (0-360).

' Set the rotation angle of a GDImage sprite object.
  DECLARE SUB ZD_SetObjectAngle LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectAngle" ( _
  byval ObjID as long, _       ' The unique sprite object identifier.
  byval AngleDegree as long, _ ' Value must fit within the 0-360 degree range.
  byval RedrawParent as long _ ' TRUE causes immediate redraw of the object parent.
  )
' Remark:
' Full rotation angle applies only to bitmap objects (OBJECT_BITMAP and OBJECT_TEXTBITMAP).
'****************************************************************************
'
'****************************************************************************
  %InterpolationModeDefault = 0
  %InterpolationModeLowQuality = 1
  %InterpolationModeHighQuality = 2'%QualityModeHigh
  %InterpolationModeBilinear = 3
  %InterpolationModeBicubic = 4
  %InterpolationModeNearestNeighbor = 5
  %InterpolationModeHighQualityBilinear = 6
  %InterpolationModeHighQualityBicubic = 7

' Version 3.00
' Get the rendering quality (interpolation mode) of a GDImage sprite object.
  DECLARE FUNCTION ZD_GetObjectQuality LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectQuality" ( _
  byval ObjID as long _  ' The unique sprite object identifier.
  ) as long
' Return:
' An interpolation mode constant (int the range 0-7).

' Set the rendering quality of a GDImage sprite object.
  DECLARE SUB ZD_SetObjectQuality LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectQuality" ( _
  byval ObjID as long, _       ' The unique sprite object identifier.
  byval Quality as long, _     ' One interpolation mode constant (in the range 0-7).
  byval RedrawParent as long _ ' TRUE causes immediate redraw of the object parent.
  )
' Remark:
' Quality must match one interpolation mode constant.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Get the 32-bit ARGB color of a GDImage object.
  DECLARE FUNCTION ZD_GetObjectARGBcolor LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectARGBcolor" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' The ARGB color with Alpha channel.

' Set the 32-bit ARGB color of a GDImage object (including its Alpha channel)
  DECLARE SUB ZD_SetObjectARGBcolor LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectARGBcolor" ( _
  byval ObjID as long, _  ' The unique sprite object identifier.
  byval UseARGB as long _ ' The ARGB color with Alpha channel.
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Get the flip mode of a specific bitmap sprite object.
  DECLARE FUNCTION ZD_GetObjectFlipMode LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectFlipMode" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' The flip mode, that is a combination of the (ZD_Reverse = 2) and/or (ZD_Flip = 1) constant.

' Set the flip mode of a specific bitmap sprite object.
  DECLARE SUB ZD_SetObjectFlipMode LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectFlipMode" ( _
  byval ObjID as long, _      ' The unique sprite object identifier.
  byval FipMode as long _     ' A combination of the (ZD_Reverse = 2) and/or (ZD_Flip = 1) constant.
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Get the rotation angle of a specific bitmap sprite object.
  DECLARE FUNCTION ZD_GetObjectRotation LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectRotation" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' The rotation angle in degree.

' Set the rotation mode of a specific bitmap sprite object.
  DECLARE SUB ZD_SetObjectRotation LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectRotation" ( _
  byval ObjID as long, _      ' The unique sprite object identifier.
  byval AngleDegree as long _ ' The rotation angle in degree.
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Update the clone ID parameter of a specific bitmap sprite object.
  DECLARE SUB ZD_SetObjectClone LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectClone" ( _
  byval ObjID as long, _  ' The unique sprite object identifier.
  byval CloneID as long _ ' The new clone ID to use
  )
' Remark:
' Internal use only!

' Get the clone ID parameter of a specific bitmap sprite object.
  DECLARE FUNCTION ZD_GetObjectClone LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectClone" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' The unique ID of the clone object if any.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Get the TRUE/FALSE PNG variable opacity status of a bitmap sprite object.
  DECLARE FUNCTION ZD_GetObjectOpacity LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectOpacity" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' A boolean True(-1) or False(0) value.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' To change (on the fly) the bitmap associated to a GDImage bitmap sprite object.
  DECLARE FUNCTION ZD_SetObjectBitmapFromFile LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectBitmapFromFile" ( _
  zFullName as asciiz, _       ' Full path name to any of the supported graphic format.
  byval ObjID as long, _       ' The unique sprite object identifier.
  byval RedrawParent as long _ ' TRUE causes immediate redraw of the object parent.
  ) as long
' Remark:
' The file can use any of the supported raster graphic format.
' Return:
' The new bitmap handle
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Create a bitmap sprite object from a text using a True Type Font.
  DECLARE FUNCTION ZD_CreateBitmapFromText LIB "GDIMAGE.DLL" ALIAS "ZD_CreateBitmapFromText" ( _
  zUseText as asciiz, _                 ' The text string to convert to bitmap.
  zUseFont as asciiz, _                 ' The True Type Font to use.
  byval UseSize as long, _              ' The pixel size to use.
  byval ColrARGB as long, _             ' The ARGB color to use
  OPTIONAL byval Use3D as long, _       ' The shadow 3D offset.
  OPTIONAL byval UseStrFormat as long _ ' Not needed
  ) as long
' Return:
' The bitmap handle of the new OBJECT_TEXTBITMAP.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Replace the bitmap of an existing bitmap sprite object with a new one.
  DECLARE SUB ZD_SetObjectBitmapFromBitmap LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectBitmapFromBitmap" ( _
  byval hBitmap as long, _     ' The new bitmap to use.
  byval ObjID as long, _       ' The unique sprite object identifier.
  byval RedrawParent as long _ ' TRUE causes immediate redraw of the object parent.
  )
' Remark:
' This is suitable to perform animation of a bitmap sprite object.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' GDImage 32-bit alphablend API to display bitmap with transparent or semitransparent pixels.
  DECLARE SUB ZI_AlphaBlendEx LIB "GDIMAGE.DLL" ALIAS "ZI_AlphaBlendEx" ( _
  byval hDCDest as long, _     ' Hhandle to destination DC.
  byval xDest as long, _       ' X-coord of upper-left corner.
  byval yDest as long, _       ' Y-coord of upper-left corner.
  byval wDest as long, _       ' Destination width.
  byval hDest as long, _       ' Destination height.
  byval hDCSrce as long, _     ' Handle to source DC.
  byval xSrce as long, _       ' X-coord of upper-left corner.
  byval ySrce as long, _       ' Y-coord of upper-left corner.
  byval wSrce as long, _       ' Source width.
  byval hSrce as long, _       ' Source height.
  byval Alpha as long, _       ' Alpha level in the range 0-255 (0 = transparent, 255 = opaque).
  byval AngleDegree as long, _ ' Rotation angle in degree.
  byval Quality as long _      ' Interpolation mode.
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Display the common save to file dialog providing a valid hParent and hGDImageCtrl handle.
  DECLARE FUNCTION ZI_SaveLayersDialog LIB "GDIMAGE.DLL" ALIAS "ZI_SaveLayersDialog" ( _
  byval hParent as long, _      ' The parent window handle.
  byval hGDImageCtrl as long, _ ' The GDImage control handle.
  byval Quality as long,  _     ' Use this for JPEG quality.
  byval Orientation as long, _  ' Orientation mode.
  byval UseWidth as long, _     ' Optional parameter to fit the image into a specific width.
  byval UseHeight as long _     ' Optional parameter to fit the image into a specific height.
  ) as long
' Return:
' Error code in case of error, zero if succesful.
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Update the SCROLLINFO structure of a GDImage Zoom control.
  DECLARE SUB ZI_SetZoomScrollInfo LIB "GDIMAGE.DLL" ALIAS "ZI_SetZoomScrollInfo" ( _
  byval hGDImageCtrl as long, _   ' The GDImage control handle.
  byval OldZoomValue AS SINGLE, _ ' Old zoom value
  byval ZoomValue AS SINGLE _     ' New zoom value
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.00
' Set the positive or negative value of the 3D shadow offset for text and vector sprite objects.
  DECLARE SUB ZD_SetObjectUse3Dshadow LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectUse3Dshadow" ( _
  byval ObjID as long, _  ' The unique sprite object identifier.
  byval Use3D as long _   ' The positive or negative shadow offset value.
  )
' Remark:
' Negative value = shadow offset bottom left.
' Positive value = shadow offset bottom right.

' Get the sprite object 3D shadow offset.
  DECLARE FUNCTION ZD_GetObjectUse3Dshadow LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectUse3Dshadow" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' The positive or negative value for the 3D shadow offset if any.
'****************************************************************************
'
'****************************************************************************
' Version 3.01
' Get the bitmap associated to a GDImage sprite OBJECT_BITMAP.
  DECLARE FUNCTION ZD_GetObjectBitmap LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectBitmap" ( _
  byval ObjID as long _ ' The unique sprite object identifier.
  ) as long
' Return:
' The OBJECT_BITMAP handle if any.
'****************************************************************************
'
'****************************************************************************
' Version 3.01
' Resize an existing bitmap into a new one using the specificied width and height size.
  DECLARE FUNCTION ZI_ResizeBitmapFromBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_ResizeBitmapFromBitmap" ( _
  byval BmpSrce as long, _  ' The bitmap to duplicate.
  byval UseWidth as long, _ ' Width of the new bitmap to create.
  byval UseHeight as long _ ' Height of the new bitmap to create.
  ) as long
' Return:
' A valid GDI bitmap handle, or NULL in case of error.
'****************************************************************************
'
'****************************************************************************
' Version 3.01
' Load and resize a bitmap from file into one single step.
  DECLARE FUNCTION ZI_ResizeBitmapFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_ResizeBitmapFromFile" ( _
  zFullName as asciiz, _    ' Full path name to any of the supported graphic format.
  byval UseWidth as long, _ ' Width of the new bitmap to create.
  byval UseHeight as long _ ' Height of the new bitmap to create.
  ) as long
' Return:
' A valid bitmap handle or NULL in case of error.
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Enable the drawing of a rectangular section in XOR mode using the left mouse button.
  DECLARE SUB ZI_EnableCropRectangle LIB "GDIMAGE.DLL" ALIAS "ZI_EnableCropRectangle" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  )
' Remark:
' Once selected, the rectangular section can be resized.
' Once done, click on the right mouse button to pop up the contextuel menu "Select, Cancel"
' or use "double click" to validate the selection.
'
' Important:
' In case of validation, GDImage post a WM_COMMAND message to the parent owner of the control
' using a ZM_Crop notification this way:
' PostMessage(GetParent(GDImageControl), WM_COMMAND, MAKLNG(GetDlgCtrlID(GDImageControl), ZM_Crop), MenuChoice)
' The (lParam) MenuChoice = 1, means the selection has been validated.
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Disable (cancel) the drawing of a rectangular section.
  DECLARE SUB ZI_DisableCropRectangle LIB "GDIMAGE.DLL" ALIAS "ZI_DisableCropRectangle" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  )
' See also:
' ZI_EnableCropRectangle
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Disable any drawing tool.
  DECLARE SUB ZI_DisableAllTools LIB "GDIMAGE.DLL" ALIAS "ZI_DisableAllTools" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  )
' See also:
' ZI_EnableCropRectangle
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' To edit the language being used for the contextual popup menu.
  DECLARE SUB ZI_SetCropPopupText LIB "GDIMAGE.DLL" ALIAS "ZI_SetCropPopupText" ( _
  zMenu as asciiz _ ' The text of the popup menu (use "," as delimiter) ex: "Select,Cancel"
  )
' See also:
' ZI_EnableCropRectangle
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Get the coordinates of the rectangular selected area.
  DECLARE SUB ZI_GetCropCoordinates LIB "GDIMAGE.DLL" ALIAS "ZI_GetCropCoordinates" ( _
  BYREF x as long, _        ' Crop X location
  BYREF y as long, _        ' Crop Y location
  BYREF UseWidth as long, _ ' Crop Width
  BYREF UseHeight as long _ ' Crop Height
  )
' Remark:
' This must be done in the GDImage parent form,
' while you process the WM_COMMAND message to detect for the ZM_Crop notification.
' See also:
' ZI_EnableCropRectangle
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Create a bitmap matching a GDImage control selected area.
  DECLARE FUNCTION ZI_CropWindowToBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_CropWindowToBitmap"( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval x as long, _            ' Crop X location
  byval y as long, _            ' Crop Y location
  byval UseWidth as long, _     ' Crop Width
  byval UseHeight as long _     ' Crop Height
  ) as long
' Return:
' A valid GDI bitmap handle, or NULL in case of error.
' See also:
' ZI_EnableCropRectangle
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Copy a GDImage DIB into the clipboard as a compatible bitmap.
  DECLARE FUNCTION ZI_PutBitmapToClipboard LIB "GDIMAGE.DLL" ALIAS "ZI_PutBitmapToClipboard" ( _
  byval ThisBitmap as long _ ' A valid GDImage DIB bitmap handle
  ) as long
' Return:
' A boolean True(-1) in case of succes or False(0) in case of error.
' Remark:
' The clipboard is unable to store bitmap larger than 16Gb.
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Get the TRUE or FALSE selected status of a sprite object.
  DECLARE FUNCTION ZD_GetObjectSelected LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectSelected" ( _
  byval ObjID as long _  ' The unique sprite object identifier.
  ) as long
' Return:
' True(-1) if selected or False(0) if unselected.
' See also:
' ZD_SetObjectSelected
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Set the TRUE or FALSE selected status of a sprite object.
  DECLARE SUB ZD_SetObjectSelected LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectSelected" ( _
  byval ObjID as long, _       ' The unique sprite object identifier.
  byval OnOff as long, _       ' True = Enabled (Selected) or False = Disabled (default)
  byval RedrawParent as long _ ' TRUE causes immediate redraw of the object parent
  )
' See also:
' ZD_GetObjectSelected
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Clear all selected objects matching a specific GDImage control.
  DECLARE SUB ZI_ClearObjectSelected LIB "GDIMAGE.DLL" ALIAS "ZI_ClearObjectSelected" ( _
  byval hGDImageCtrl as long _ ' The GDImage control handle.
  )
' See also:
' ZD_GetObjectSelected, ZD_SetObjectSelected
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Detect if there is any selected object in a specific GDImage control.
  DECLARE FUNCTION ZI_ObjectSelected LIB "GDIMAGE.DLL" ALIAS "ZI_ObjectSelected" ( _
  byval hGDImageCtrl as long _ ' The GDImage control handle.
  ) as long
' Return:
' The ID of the first selected object found.
' See also:
' ZD_GetObjectSelected, ZD_SetObjectSelected, ZI_ClearObjectSelected
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Retrieve all the properties of a GDImage sprite object in one single step.
  DECLARE SUB ZD_GetObjectProperties LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectProperties" ( _
  byval ObjID as long, _       ' The unique sprite object identifier.
  zDetail AS ZOBJECT _         ' Reference to the matching ZOBJECT structure.
  )
' Remark:
' This is a low level GDImage API.
' See also:
' ZD_SetObjectProperties
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Update all the propreties of a GDImage sprite object in one single step.
  DECLARE SUB ZD_SetObjectProperties LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectProperties" ( _
  byval ObjID as long, _       ' The unique sprite object identifier.
  zDetail AS ZOBJECT _         ' Reference to the matching ZOBJECT structure.
  )
' Remark:
' This is a low level GDImage API.
' See also:
' ZD_GetObjectProperties
'****************************************************************************
'
'****************************************************************************
' Version 3.02
' Flatten all layers (visible sprite objects) with respect of their z-order, into a new memory bitmap.
  DECLARE FUNCTION ZI_RenderLayersToBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_RenderLayersToBitmap" ( _
  byval hGDImageCtrl as long _ ' The GDImage control handle.
  ) as long
' Return:
' The handle of the new memory bitmap.
' See also:
' ZI_RenderLayersToFile
'****************************************************************************
'
'****************************************************************************
' Version 3.50
' Low level procedure to get the Windows temp directory path.
  DECLARE FUNCTION zGetTempPath LIB "GDIMAGE.DLL" ALIAS "zGetTempPath" () AS STRING
' Return:
' The full qualified Windows temp directory path.
'****************************************************************************
'
'****************************************************************************
' Version 3.50
' Low level procedure to delete file (remove) file from disk (the file is not sent to tray).
  DECLARE FUNCTION zKillFile LIB "GDIMAGE.DLL" ALIAS "zKillFile" (zFullName as asciiz) as long
' Return:
' Error code in case of error, zero if succesful.
'****************************************************************************
'
'****************************************************************************
' Version 3.50
' Move the specified file to tray.
  DECLARE FUNCTION ZI_MoveToTray LIB "GDIMAGE.DLL" ALIAS "ZI_MoveToTray"(zFullName as asciiz) as long
' Return:
' Error code in case of error, zero if succesful.
'****************************************************************************
'
'****************************************************************************
' Version 3.50
' Display the GDImage dialog True Type Font Text editor.
  DECLARE FUNCTION ZI_FontBox LIB "GDIMAGE.DLL" ALIAS "ZI_FontBox" ( _
  byval hParent as long, _  ' The parent window handle.
  zCaption as asciiz, _     ' The font box caption.
  zUseText as asciiz, _     ' The string to edit.
  zUseFont as asciiz, _     ' The font to use.
  BYREF UseSize as long, _  ' The pixel size to use.
  BYREF ColrARGB as long, _ ' The ARGB color to use
  BYREF Use3D as long _     ' The shadow 3D offset.
  ) as long
' Return:
' Return = 2 when the user clic the "Ok" button to validate the input, any other value must be ignored.
'****************************************************************************
'
'****************************************************************************
' Version 3.50
' To change the default Font Box parameters.
  DECLARE SUB ZI_SetFontBoxParameters LIB "GDIMAGE.DLL" ALIAS "ZI_SetFontBoxParameters" ( _
  byval SquareSize as long, _    ' Default 640 x 640 pixels
  byval MaxFontSize as long, _   ' Default 512 pixels
  byval TextCharLength as long _ ' Default 64 characters
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.50
' The Crop tool status mode.
  DECLARE FUNCTION ZI_GetToolCropStatus LIB "GDIMAGE.DLL" ALIAS "ZI_GetToolCropStatus" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Return:
' True = Crop status is On, False = Crop status is false.
'****************************************************************************
'
'****************************************************************************
' Version 3.50
' Get the font string format of a text sprite object.
  DECLARE FUNCTION ZD_GetStringFormat LIB "GDIMAGE.DLL" ALIAS "ZD_GetStringFormat" ( _
  byval ObjID as long _        ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  ) as long
' Return:
' A constant value, matching the current string format: ZD_TextHorzUp, ZD_TextVertUp, ZD_TextVertDn
'****************************************************************************
'
'****************************************************************************
' Version 3.50
' Set the font string format of a text sprite object.
  DECLARE SUB ZD_SetStringFormat LIB "GDIMAGE.DLL" ALIAS "ZD_SetStringFormat" ( _
  byval ObjID as long, _       ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  byval StrFormat as long, _   ' The constant value to use: ZD_TextHorzUp, ZD_TextVertUp, ZD_TextVertDn
  byval RedrawParent as long _ ' TRUE causes immediate redraw of the object parent
  )
'****************************************************************************
'
'****************************************************************************
' Version 3.51
' List of parameters
' szProfileName =  A profile name, limited to 256 characters or less. This is the profile
'                  to use when logging on. If you pass an empty string, and the flFlags
'                  parameter is set to %MAPI_LOGON_UI, MAPILogon displays a logon dialog
'                  box with an empty name field.
' szPassword    =  A credential string, limited to 256 characters or less. If the
'                  messaging system does not require password credentials, or if it
'                  requires that the user enter them, the strPassword parameter should be
'                  an empty string. When the user must enter credentials, the flFlags
'                  parameter must be set to %MAPI_LOGON_UI to allow a logon dialog box to
'                  be displayed.
' szSubject     =  Subject of the email.
' szNote        =  Email text.
' szAddresses   =  A list of email addresses separated by ;'s Make sure to put in the
'                  message type preceded by a : if it's not being delivered to an MS Mail
'                  post office. For example, if you're sending mail out to the internet
'                  via MS Mail, the mail type is SMTP. You will need to preceed the
'                  address with SMTP:
'                  e.g. "SMTP:ddickinson@usinternet.com;SMTP:ddickinson@compuserve.com"
' szFiles       =  A list of ; delimited file names (full drive letter, file path and file
'                  name must be included). If the file doesn't exist (DIR$(FileName) = "")
'                  then it will be ignored.
  DECLARE FUNCTION zSendMapiMail LIB "GDIMAGE.DLL"  ALIAS "zSendMapiMail" ( _
  szProfileName as asciiz, _
  szPassword as asciiz, _
  szSubject as asciiz, _
  szNote as asciiz, _
  szNames as asciiz, _
  szAddresses as asciiz, _
  szFiles as asciiz _
  ) as dword
' Return:
' A MAPI Error code if any, and null in case of success.
'****************************************************************************
'
'****************************************************************************
' Version 3.51 (pro version only)
' Put the focus on a specific GDImage sprite object.
  DECLARE SUB ZI_SetObjectFocusID LIB "GDIMAGE.DLL" ALIAS "ZI_SetObjectFocusID" ( _
  byval ObjID as long _        ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  )
' Remark:
' Same effect that to clic with the left mouse button on a GDImage sprite object.
'****************************************************************************
'
'****************************************************************************
' Version 3.51
' Get the number of objects being used in a specific GDImage control.
  DECLARE FUNCTION ZI_GetCtrlObjectCount LIB "GDIMAGE.DLL" ALIAS "ZI_GetCtrlObjectCount" ( _
  byval hGDImageCtrl as long _ ' The GDimage control handle.
  ) as long
' Return:
' The object count.
'****************************************************************************
'
'****************************************************************************
' Version 3.51
' Get the alpha channel value of a specific GDImage object.
  DECLARE FUNCTION ZD_GetObjectAlpha LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectAlpha" ( _
  byval ObjID as long _        ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  ) as long
' Return:
' The alpha channel value in the range 0-255 (0 = full transparency, 255 = full opacity).
'****************************************************************************
'
'****************************************************************************
' Version 3.51
' To create a tooltip, to be used with a GDImage control.
  DECLARE FUNCTION ZI_CreateToolTip LIB "GDIMAGE.DLL" ALIAS "ZI_CreateToolTip" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  zText as asciiz _             ' The tooltip text to display.
  ) as long
' Return:
' The handle of the tooltip.
'
' Remark:
' This function must be called only once, to create the initial tooltip container.
' To change the text of the tooltip when the mouse hover a specific object, use ZI_SetToolTipText.
'
' Usualy the tooltip text matches the object label.
'****************************************************************************
'
'****************************************************************************
' Version 3.51
' To change the text of an existing GDImage control tooltip.
  DECLARE SUB ZI_SetToolTipText LIB "GDIMAGE.DLL" ALIAS "ZI_SetToolTipText" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  zText as asciiz _             ' The tooltip text to display.
  )
' Remark:
' The tooltip must have been first created with ZI_CreateToolTip.
' Usualy the tooltip text matches the object label.
' It is of the programmer's responsability to change the text of the tooltip
' when the mouse hover a specific GDImage object.
'****************************************************************************
'
'****************************************************************************
' Version 3.52
' Create a square canvas using a specific size to stretch the source bitmap into it.
' Note: a sprite always use a square size to ease further rotation computation.
  DECLARE FUNCTION ZI_CreateSpriteFileFromBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_CreateSpriteFileFromBitmap" ( _
  zFullPathName as asciiz, _      ' The full path name of the sprite graphic file to create
  byval BmpSrce as long, _        ' The source bitmap to create the sprite from.
  byval UseSize as long, _        ' The size of the sprites's canvas square (16, 32, 64, 128, 256, 512)
  byval JpegQuality as long _     ' In case of JPEG format, the encoding quality 1-100
  )as long
' Return:
' A status error code, or null in case of success.
' Remark:
' Stretching is done using high quality bicubic interpolation.
'****************************************************************************
'
'****************************************************************************
' Version 3.52
' Open the GDImage common save dialog to select a specific folder and enter/edit the filename.
  DECLARE FUNCTION ZI_ChooseSaveFileName LIB "GDIMAGE.DLL" ALIAS "ZI_ChooseSaveFileName" ( _
  byval hParent as long, _        ' The parent window handle.
  zDefaultName as asciiz _        ' The default file name to edit.
  ) AS STRING
' Return:
' The full path name of the file to save.
' Remark:
' Once you have got the file name, you can use: ZI_SaveToFile
' See also:
' ZI_SaveDialog
'****************************************************************************
'
'****************************************************************************
'//3.55
' To create a variable opacity PNG file from any of the supported graphic file format.
  DECLARE FUNCTION ZI_CreateVariableOpacityPNG LIB "GDIMAGE.DLL" ALIAS "ZI_CreateVariableOpacityPNG" ( _
  zInputName as asciiz, _  ' Full path name of the input graphic file to convert.
  zOutputName as asciiz _  ' Full path name to the output PNG graphic file to create.
  ) as long
' Remark:
' The zOutputName is always a PNG graphic file using the .png extension.
' Return:
' A status generic error or null if all went fine.
'****************************************************************************
'
'****************************************************************************
'//3.55
' Create a variable opacity memory bitmap, from any of the supported graphic file format.
  DECLARE FUNCTION ZI_CreateVariableOpacityBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_CreateVariableOpacityBitmap" ( _
  zInputName as asciiz, _  ' Full path name of the input graphic file source.
  imgW as long, _          ' Width of the image.
  imgH as long _           ' Height of the image.
  ) as long
' Return:
' A valid bitmap handle or null in case of error.
'****************************************************************************
'
'****************************************************************************
'//3.55
' Add a TEXT bitmap sprite object to a GDImage control.
  DECLARE FUNCTION ZD_DrawTextBitmapToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawTextBitmapToCtrl" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval x as long, _                   ' The X coordinate.
  byval y as long, _                   ' The Y coordinate.
  byval hBitmap as long, _             ' The TEXT bitmap to use.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ZS_STYLE as long _             ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  ) as long
' Remark:
' The TEXT bitmap must have been created first using ZD_CreateBitmapFromText
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 4.01
' Return the number of selected object in a specific GDImage control.
  DECLARE FUNCTION ZI_SelectedCount LIB "GDIMAGE.DLL" ALIAS "ZI_SelectedCount" ( _
  byval hGDImageCtrl as long _ ' The GDImage control handle.
  ) as long
' Return:
' The selected object Count.
' See also:
' ZD_GetObjectSelected, ZD_SetObjectSelected, ZI_ClearObjectSelected
'****************************************************************************
'
'****************************************************************************
'//3.57
' Retrieve the unique IDentifier of the first object whose bound limits are hovered by the mouse.
' Its primary purpose it to be used from a ZI_EventMessage callback.
  DECLARE FUNCTION ZI_MouseHoverBoundID LIB "GDIMAGE.DLL" ALIAS "ZI_MouseHoverBoundID" () as long
' Return:
' The unique IDentifier of the matching GDImage sprite object.
'****************************************************************************
'
'****************************************************************************
'//3.57
' Create a GDIPLUS compatible 32-bit DIB DC.
  DECLARE FUNCTION ZI_Create32bitDC LIB "GDIMAGE.DLL" ALIAS "ZI_Create32bitDC" ( _
  byval nWidth as long, _      ' The DIB width.
  byval nHeight as long, _     ' The DIB height.
  byval ARGBcolor as long _    ' FULL ARGB color to paint the DIB background.
  ) as long
' Return:
' The DC (device context) of the 32-bit DIB or NULL in case of error.
'****************************************************************************
'
'****************************************************************************
'//3.57
' Create an empty image background (Bitmap) into a GDImage control.
' Use it to perform direct drawing, everything lying out of it (overlay objects) would be clipped.
  DECLARE FUNCTION ZI_CreateImageBackgroundEx LIB "GDIMAGE.DLL" ALIAS "ZI_CreateImageBackgroundEx" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  byval BitmapWidth as long, _         ' The width of the bitmap.
  byval BitmapHeight as long, _        ' The Height of the bitmap.
  byval UseColor as long, _            ' a 24-bit RGB color or 32-bit ARGB color if BitPerPixel = 32
  byval BitPerPixel as long _          ' 24 or 32-bit
  ) as long
' Return:
' A valid GDImage DC (ZI_GetDC) you can use to draw in.
' Note: After drawing into the provided DC, use ZI_UpdateWindow to refresh the display.
'****************************************************************************
'
'****************************************************************************
'//3.56
' Paint a sprite object onto the background of a specific GDImage control.
  DECLARE FUNCTION ZD_CopyToBackground LIB "GDIMAGE.DLL" ALIAS "ZD_CopyToBackground" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval ObjID as long, _        ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ClearBack as long, _    ' Boolean flag, use %TRUE to paint first the background with the following RGBcolor.
  byval RGBColor as long _      ' The RGB color to use to paint the bitmap background if ClearBack = %TRUE.
  ) as long
' Return:
' None.
'****************************************************************************
'
'****************************************************************************
'//2.11
' Flip a bitmap sprite object horizontaly.
  DECLARE SUB ZD_FlipObjectX LIB "GDIMAGE.DLL" ALIAS "ZD_FlipObjectX" ( _
  byval ObjID as long _        ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  )
' Remark:
' The type of the sprite object must be: OBJECT_BITMAP or OBJECT_TEXTBITMAP exclusively.
'****************************************************************************
'
'****************************************************************************
'//2.11
' Flip a bitmap sprite object verticaly.
  DECLARE SUB ZD_FlipObjectY LIB "GDIMAGE.DLL" ALIAS "ZD_FlipObjectY" ( _
  byval ObjID as long _        ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  )
' Remark:
' The type of the sprite object must be: OBJECT_BITMAP or OBJECT_TEXTBITMAP exclusively.
'****************************************************************************
'
'****************************************************************************
'//2.11
' Rotate a bitmap sprite object by step of 90 counter clock.
  DECLARE SUB ZD_RotateObjectCounterclock90 LIB "GDIMAGE.DLL" ALIAS "ZD_RotateObjectCounterclock90" ( _
  byval ObjID as long _        ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  )
' Remark:
' The type of the sprite object must be: OBJECT_BITMAP or OBJECT_TEXTBITMAP exclusively.
'****************************************************************************
'
'****************************************************************************
'//2.11
' Rotate a bitmap sprite object by step of 90 clock wise.
  DECLARE SUB ZD_RotateObjectClockWise90 LIB "GDIMAGE.DLL" ALIAS "ZD_RotateObjectClockWise90" ( _
  byval ObjID as long _        ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  )
' Remark:
' The type of the sprite object must be: OBJECT_BITMAP or OBJECT_TEXTBITMAP exclusively.
'****************************************************************************
'
'****************************************************************************
'//3.56
' To retrieve the IDentifier of the sprite object that has captured the mouse.
  DECLARE FUNCTION ZD_ObjectMouseCaptured LIB "GDIMAGE.DLL" ALIAS "ZD_ObjectMouseCaptured" () as long
' Return:
' A GDImage sprite object IDentifier or NULL if none has captured the mouse.
'****************************************************************************
'
'****************************************************************************
'//3.57
' Replace the bitmap of a specific GDImage sprite object with a new one.
' Note: it also affects this new bitmap to the related clones if any.
  DECLARE SUB ZD_ReplaceObjectBitmap LIB "GDIMAGE.DLL" ALIAS "ZD_ReplaceObjectBitmap" ( _
  byval hBitmap as long, _     ' The new bitmap to use.
  byval ObjID as long, _       ' The unique sprite object identifier.
  byval RedrawParent as long _ ' TRUE causes immediate redraw of the object parent.
  )
' Remark:
' The type of the sprite object must be: OBJECT_BITMAP or OBJECT_TEXTBITMAP exclusively.
'****************************************************************************
'
'****************************************************************************




' Undocumented features
' *********************
'//3.53
' To set/get the default Load Dialog file extension.
  DECLARE FUNCTION ZI_SetLoadExtension LIB "GDIMAGE.DLL" ALIAS "ZI_SetLoadExtension" ( _
  zExtension as asciiz, _  ' The file extension to use.
  byval RW as long _       ' TRUE = Set extension, FALSE = Read extension.
  ) AS STRING
' Remark:
' File extension must be of the form "*.PCS (PhotoComposer Script)|*.pcs"

'//3.53
' To set/get the default Save Dialog file extension.
  DECLARE FUNCTION ZI_SetSaveExtension LIB "GDIMAGE.DLL" ALIAS "ZI_SetSaveExtension" ( _
  zExtension as asciiz, _  ' The file extension to use.
  byval RW as long _       ' TRUE = Set extension, FALSE = Read extension.
  ) AS STRING
' Remark:
' File extension must be of the form "*.PCS (PhotoComposer Script)|*.pcs"

'//3.56
' Returns a registry string.
  DECLARE FUNCTION zGetReg LIB "GDIMAGE.DLL" ALIAS "zGetReg" (byval hLocation as dword, zSubKeys as asciiz, zValueName as asciiz) AS STRING

'//3.56
' Saves a string value to the registry, returns nonzero if successful.
  DECLARE FUNCTION zSetReg LIB "GDIMAGE.DLL" ALIAS "zSetReg" (byval hLocation as dword, zSubKeys as asciiz, zValueName as asciiz, zData as asciiz) as long

'//3.56
' To check the Hidden status of a GDImage sprite object.
  DECLARE FUNCTION ZD_IsObjectHidden LIB "GDIMAGE.DLL" ALIAS "ZD_IsObjectHidden" ( _
  byval ObjID as long _         ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long
' See also:
' ZD_SetObjectHidden

'//3.56
' Set the HIDDEN state of a GDImage sprite object.
  DECLARE SUB ZD_SetObjectHidden LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectHidden" ( _
  byval ObjID as long, _        ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval OnOff as long _         ' Boolean TRUE / FALSE condition.
  )
' Remark:
' Hidden state should not be confused with the Visibility state.
' This is a low level feature being used to draw Hollow sprite objects.
' Such object can be used to follow or replace the mouse cursor.
' See also:
' ZD_IsObjectHidden.

'//3.57
' Create a GDIPLUS image attribute to remap a specific ARGB color from one color to another.
  DECLARE FUNCTION ZI_RemapImageColor LIB "GDIMAGE.DLL" ALIAS "ZI_RemapImageColor" ( _
  byval nColorFrom as long, _  ' Previous ARGB color to remap .
  byval nColorTo as long _     ' New ARGB color to use.
  ) as long
' Return:
' A GDIPLUS ImageAttribute

'//3.57
' Create a GDIPLUS image attribute to remap a specific ARGB color along the full alpha channel range (0-255).
  DECLARE FUNCTION ZI_RemapAlphaColor LIB "GDIMAGE.DLL" ALIAS "ZI_RemapAlphaColor" ( _
  byval nColorFrom as long, _  ' Previous ARGB color to remap .
  byval nColorTo as long _     ' New ARGB color to use.
  ) as long
' Return:
' A GDIPLUS ImageAttribute

''//3.57
'' Fills a rectangle using a specific 32-bit ARGB color.
'  DECLARE SUB ZI_PaintBrushBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_PaintBrushBitmap" ( _
'  byval hDC as long, _        ' A valid 32-bit DC
'  byval x as long, _          ' The top left horizontal coordinate of the rectangle
'  byval y as long, _          ' The top left vertical coordinate of the rectangle
'  byval xW as long, _         ' The rectangle width
'  byval yH as long, _         ' The rectangle height
'  byval ARGBcolor as long _   ' The ARGB color to use
'  )

'// 4.02 SpritePlus set bit array to handle event message
' Monitor the Windows message flow using a callback to take control over the GDImage default procedure.
  DECLARE SUB ZI_EventMessageEx LIB "GDIMAGE.DLL" ALIAS "ZI_EventMessageEx" ( _
  byval hWnd as long, _        ' The GDimage control handle.
  byval pCodePtr as dword, _   ' Pointer to a MyCallback function (see remark below).
  byval WM_Message as long, _  ' The Windows message to filter.
  byval SetReset as long _     ' TRUE = enable, FALSE = disable callback for the specific message.
  )
' Remark:
' FUNCTION MyCallBack( _       ' Use any name, and provide its code pointer to ZI_EventMessage
' byval hWnd as long, _        ' The GDImage control handle sending the event.
' byval Msg as long, _         ' Any standard Windows message.
' byval wParam as long, _      ' The contents of this parameter depend on the value of the Msg parameter.
' byval lParam as long _       ' The contents of this parameter depend on the value of the Msg parameter.
' ) as long                    ' See MSDN documentation about using a WindowProc function.
'
' Important:
' If you want to stop further processing of the message by GDImage, then the callback function must return TRUE.

'///////////////////////////////////////////////////////////////////////////////////////////////////////////////

'//4.03
'  Create a GDImage animated clock control
   DECLARE FUNCTION zClockCtrl LIB "GDIMAGE.DLL" ALIAS "zClockCtrl" ( _
   byval hOwner as long, _            ' Handle of the window parent owner.
   zFullpathImageName as asciiz, _    ' Full path name to the clock image background.
   byval x as long, _                 ' X location of the clock control.
   byval y as long, _                 ' Y location of the clock control.
   byval W as long, _                 ' Width of the clock control.
   byval H as long, _                 ' Height of the clock control.
   byval ButID as long, _             ' Unique ID of the clock control.
   byval ARGB1 as long, _             ' The color to draw the Hour/Minute hands.
   byval ARGB2 as long, _             ' The color to draw the second hands.
   OPTIONAL byval GMToffset as long _ ' The GMT offset to be used.
   ) as long
   %DISABLE_TIMER = 99 '// Use this value in the optional GMToffset parameter to disable local timer in case of animated background
 
'//4.05
' Useful to embend an image into a fixed size square to perform image rotation from the center
' Example 512 x 512 or 1024 x 1024 or 2048 x 2048 or 1024 x 512 (for texture creation)
  DECLARE FUNCTION ZI_FitBitmapFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_FitBitmapFromFile" ( _
  zFullPath as asciiz, _       ' Full path name to image
  byval Xin as long, _         ' Width of the container
  byval Yin as long _          ' Height of the container
  ) as long
  
' Paper size 152 x 102 or 233 x 152  
  DECLARE FUNCTION ZI_FitImageToPaper LIB "GDIMAGE.DLL" ALIAS "ZI_FitImageToPaper" ( _
  zImageSrce as asciiz, _      ' Full path to image source
  byval nPaperW as long, _     ' paper width in mm
  byval nPaperH as long, _     ' paper height in mm
  zCropedImageDest as asciiz _ ' Full path to the resulting croped image
  ) as long

' Effects

'//4.05
  DECLARE FUNCTION ZD_GetObjectBrightness LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectBrightness" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long

'//4.05
  DECLARE SUB ZD_SetObjectBrightness LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectBrightness" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval Brightness as long, _          ' The brightness level in the range (range 0-255, 0 = default).
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )

'//4.05
  DECLARE FUNCTION ZD_GetObjectContrast LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectContrast" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long

'//4.05
  DECLARE SUB ZD_SetObjectContrast LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectContrast" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval Contrast as long, _            ' The contrast level in the range (range 0-255, 0 = default).
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )

'//4.05
  DECLARE FUNCTION ZD_GetObjectRed LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectRed" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long

'//4.05
  DECLARE SUB ZD_SetObjectRed LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectRed" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval nRed as long, _                ' The red level in the range (range 0-255, 0 = default).
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )

'//4.05
  DECLARE FUNCTION ZD_GetObjectGreen LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectGreen" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long

'//4.05
  DECLARE SUB ZD_SetObjectGreen LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectGreen" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval nGreen as long, _              ' The green level in the range (range 0-255, 0 = default).
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )

'//4.05
  DECLARE FUNCTION ZD_GetObjectBlue LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectBlue" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long

'//4.05
  DECLARE SUB ZD_SetObjectBlue LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectBlue" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval nBlue as long, _               ' The blue level in the range (range 0-255, 0 = default).
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )

'//4.05
  DECLARE FUNCTION ZD_GetObjectHue LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectHue" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long

'//4.05
  DECLARE SUB ZD_SetObjectHue LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectHue" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval nHue as long, _                ' The Hue level in the range (range 0-255, 0 = default).
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )

'//4.05
' Apply the effects to an object bitmap.
  DECLARE FUNCTION ZD_RenderEffectToBitmapObject LIB "GDIMAGE.DLL" ALIAS "ZD_RenderEffectToBitmapObject" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  ) as long
' Return:
' The new object bitmap handle.

'//4.05
  DECLARE FUNCTION ZI_CreateBitmapFromImage LIB "GDIMAGE.DLL" ALIAS "ZI_CreateBitmapFromImage" ( _
  byval hImage as long _               ' The GDIPLUS image handle to convert into a GDI32 bitmap handle
  ) as long
' Return:
' A GDI32 bitmap handle.

'//4.05
  DECLARE FUNCTION ZI_IsAnyArrowPressed LIB "GDIMAGE.DLL" ALIAS "ZI_IsAnyArrowPressed" () as long

'//4.05
  DECLARE FUNCTION ZI_ApplyEffectToFile LIB "GDIMAGE.DLL" ALIAS "ZI_ApplyEffectToFile" ( _
  zImageSrce as asciiz, _
  zDetail AS ZOBJECT, _         ' Reference to the matching ZOBJECT structure.
  zImageDest as asciiz _
  ) as long

'//4.05 Create a Disabled Window that works with any control created directly with the API
' This creates a layered transparent window hover the window you want to disable.
'//5.05
  DECLARE FUNCTION ZI_CreateDW LIB "GDIMAGE.DLL" ALIAS "ZI_CreateDW" ( _
  byval hParent as long _
  ) as long

'//5.05 Removed (see ZI_CreateDW)
'//4.05 Show an existing Disabled Window
  'DECLARE SUB ZI_ShowDW LIB "GDIMAGE.DLL" ALIAS "ZI_ShowDW"( _
  'byval hDW as long _
  ')

'//5.05 Removed (see ZI_DestroyDW)
'//4.05 Hide an existing Disabled Window
  'DECLARE SUB ZI_HideDW LIB "GDIMAGE.DLL" ALIAS "ZI_HideDW" ( _
  'byval hDW as long _
  ')

'//4.06 Paint image in tiling mode
  DECLARE SUB ZI_ImageTilePaint LIB "GDIMAGE.DLL" ALIAS "ZI_ImageTilePaint" ( _
  byval graphics as long, _
  byval Img as long, _
  byval xOffset as long, _
  byval yOffset as long, _
  byval nPaintWidth as long, _
  byval nPaintHeight as long _
  )

''//4.06 Computes location and size to stretch a bitmap preserving its aspect.
'  DECLARE SUB ZI_ComputeAspect LIB "GDIMAGE.DLL" ALIAS "ZI_ComputeAspect" ( _
'  byval xPicSize as long, _
'  byval yPicSize as long, _
'  byval xCell as long, _
'  byval yCell as long, _
'  BYREF xPos as long, _
'  BYREF yPos as long, _
'  BYREF xSize as long, _
'  BYREF ySize as long _
'  )

'//4.06 Create a Skin background matching a specific size
  DECLARE FUNCTION ZI_CreateSkinBackground LIB "GDIMAGE.DLL" ALIAS "ZI_CreateSkinBackground" ( _
  zImageDest as asciiz, _
  byval rwX as long, _
  byval rwY as long, _
  zUseBackground as asciiz, _
  zSkinFolder as asciiz _
  ) as long

'//5.29
  DECLARE FUNCTION ZI_CreateSkinBackgroundEx LIB "GDIMAGE.DLL" ALIAS "ZI_CreateSkinBackgroundEx" ( _
  zImageDest as asciiz, _
  byval rwX as long, _
  byval rwY as long, _
  zUseBackground as asciiz, _
  zSkinFolder as asciiz, _
  byval UseStretchMode as long, _
  byval IsResizable as long, _
  byval nOverlayColor as long _
  ) as long

'//4.07 To perform self image rotation
'// %Rotate90FlipNone = 1
'// %Rotate180FlipNone = 2
'// %Rotate270FlipNone = 3
'// %RotateNoneFlipX = 4
'// %Rotate90FlipX = 5
'// %Rotate180FlipX = 6
'// %Rotate270FlipX = 7
  DECLARE FUNCTION ZI_SetImageFileOrientation LIB "GDIMAGE.DLL" ALIAS "ZI_SetImageFileOrientation" ( _
  zImageSrce as asciiz, _
  byval Orientation as long _
  ) as long

  DECLARE FUNCTION ZI_SetImageAlpha LIB "GDIMAGE.DLL" ALIAS "ZI_SetImageAlpha" ( _
  byval Alpha as long _
  ) as long
' Return:
' A valid GDIPLUS image attribute.
  
'//4.08
  DECLARE FUNCTION ZI_SetImageAttributesHue LIB "GDIMAGE.DLL" ALIAS "ZI_SetImageAttributesHue" ( _
  byval nHue as long _
  ) as long  
' Return:
' A valid GDIPLUS image attribute.

' To convert a GDI32 bitmap into a GDIPLUS image, based on a provided DC matching the GDI32 bitmap
  DECLARE FUNCTION zBitmapToImage LIB "GDIMAGE.DLL" ALIAS "zBitmapToImage" ( _
  byval hDC as long _
  ) as long
' Return:
' A GDIPLUS image handle

' To create a GDI32 DIB section
  DECLARE FUNCTION ZI_CreateDIBSection LIB "GDIMAGE.DLL" ALIAS "ZI_CreateDIBSection" ( _
  byval hDC as long, _
  byval nWidth as long, _
  byval nHeight as long, _
  byval BitCount as long _
  ) as long

' To convert a RGB value into shade of gray.
  DECLARE FUNCTION Rgb2Gray LIB "GDIMAGE.DLL" ALIAS "Rgb2Gray" ( _
  byval RGBValue as dword _
  ) as dword

' GDImage encapsulation of GDI32 Alphablend API
  DECLARE SUB zAlphaBlend LIB "GDIMAGE.DLL" ALIAS "zAlphaBlend" ( _
  byval hDcDest as long, _
  byval xDest as long, _
  byval yDest as long, _
  byval wDest as long, _
  byval hDest as long, _
  byval hDcSrce as long, _
  byval xSrce as long, _
  byval ySrce as long, _
  byval wSrce as long, _
  byval hSrce as long _
  )

' GDImage 32-bit Alphablend API
  DECLARE SUB ZI_AlphaBlend LIB "GDIMAGE.DLL" ALIAS "ZI_AlphaBlend" ( _
  byval hDCDest as long, _
  byval xDest as long, _
  byval yDest as long, _
  byval nWidth as long, _
  byval nHeight as long, _
  byval hDCSrce as long, _
  byval xCurrentScroll as long, _
  byval yCurrentScroll as long _
  )

'//4.09
  TYPE ZGLTEXTUREX
      ID       as long
      FullName as asciiz * 260
      Texture  as long
      Square   as long            '// boolean TRUE or FALSE value
      alpha    as long
  END TYPE
  
'//4.09
  DECLARE SUB ZI_MakeMultipleTexture LIB "GDIMAGE.DLL" ALIAS "ZI_MakeMultipleTexture" ( _
  byval tp AS ZGLTEXTUREX PTR, _
  byval N as long _
  )

'//5.17
  DECLARE SUB ZI_DestroyTexture LIB "GDIMAGE.DLL" ALIAS "ZI_DestroyTexture" ( _
  byval tp AS ZGLTEXTUREX PTR, _
  byval N as long _
  )

'//4.09
  DECLARE FUNCTION ZI_CreateGLTextureFromFileEX LIB "GDIMAGE.DLL" ALIAS "ZI_CreateGLTextureFromFileEX" ( _
  zFullPath as asciiz, _
  Xin as long, _
  Yin as long, _
  PixelArray() AS BYTE, _
  byval SquareTexture as long _
  ) as long

'//4.11
  DECLARE FUNCTION ZI_CenterDialog LIB "GDIMAGE.DLL" ALIAS "ZI_CenterDialog" ( _
  byval nFlag as long, _
  byval RW as long _
  ) as long

'//4.14
  DECLARE FUNCTION ZD_ARGB LIB "GDIMAGE.DLL" ALIAS "ZD_ARGB" ( _
  byval A AS BYTE, _
  byval R AS BYTE, _
  byval G AS BYTE, _
  byval B AS BYTE _
  ) as long

'//4.14
  DECLARE FUNCTION ZI_ImageFromResource LIB "GDIMAGE.DLL" ALIAS "ZI_ImageFromResource" ( _
  byval nInstance as long, _
  zName as asciiz _
  ) as long

'//4.14
  DECLARE SUB ZI_RemoveRedEye LIB "GDIMAGE.DLL" ALIAS "ZI_RemoveRedEye" ( _
  byval hDC as long, _
  byval x as long, _
  byval y as long, _
  byval UseWidth as long, _
  byval UseHeight as long _
  )

'//4.14
  DECLARE SUB ZD_RemoveRedEyeFromBitmapObject LIB "GDIMAGE.DLL" ALIAS "ZD_RemoveRedEyeFromBitmapObject" ( _
  byval nObjectID as long, _
  byval x as long, _
  byval y as long, _
  byval UseWidth as long, _
  byval UseHeight as long _
  )

'//4.14
' Enable red eye crop selection
  DECLARE SUB ZI_EnableCropRedEye LIB "GDIMAGE.DLL" ALIAS "ZI_EnableCropRedEye" ( _
  byval hWnd as long _
  )

'//4.15
  DECLARE SUB zDrawImage LIB "GDIMAGE.DLL" ALIAS "zDrawImage" ( _
  byval hDC as long, _      ' A Windows DC (do not use ZI_GetDC except if you want to paint over the image)
  byval Img as long, _      ' A valid GDImage - GDIPLUS handle.
  byval x as long, _        ' The top left corner horizontal location
  byval y as long, _        ' The top left corner vertical location
  byval xW as long, _       ' The width
  byval yH as long _        ' The height
  )

'// 4.16 To create a composited rectangle object
  DECLARE SUB ZI_CreateRectangleObject LIB "GDIMAGE.DLL" ALIAS "ZI_CreateRectangleObject" ( _
  zDetail AS ZOBJECT, _                ' Reference to the matching ZOBJECT structure.
  byval x as long, _                   ' Top left X coordinate.
  byval y as long, _                   ' Top left Y coordinate.
  byval xWidth as long, _              ' Rectangle width.
  byval yHeight as long, _             ' Rectangle height.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval BorderSize as long, _          ' Size of the border (can be NULL).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE (see below).
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  )
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect

'// 4.16 To create a composited bitmap object
  DECLARE SUB ZI_CreateBitmapObject LIB "GDIMAGE.DLL" ALIAS "ZI_CreateBitmapObject" ( _
  zDetail AS ZOBJECT, _                ' Reference to the matching ZOBJECT structure.
  byval x as long, _                   ' Top left X coordinate.
  byval y as long, _                   ' Top left Y coordinate.
  byval hBitmap as long, _             ' Bitmap handle.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval ZS_STYLE as long _             ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  )

'// 4.16 To create a composited text object
  DECLARE SUB ZI_CreateTextObject LIB "GDIMAGE.DLL" ALIAS "ZI_CreateTextObject" ( _
  zDetail AS ZOBJECT, _                ' Reference to the matching ZOBJECT structure.
  zUseText as asciiz, _                ' The text to display
  byval x as long, _                   ' Top left X coordinate.
  byval y as long, _                   ' Top left Y coordinate.
  byval xWidth as long, _              ' Rectangle width.
  byval yHeight as long, _             ' Rectangle height.
  byval ColrARGB as long, _            ' The ARGB color to use.
  zUseFont as asciiz, _                ' The "Tue Type Font" name to use
  byval UseSize as long, _             ' The size of the font in pixel
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval Use3D as long, _               ' The shadow 3D offset
  byval UseStrFormat as long _         ' Any of the %StringAlignment below 
  )
  %StringAlignmentNear = 0
  %StringAlignmentCenter = 1
  %StringAlignmentFar = 2

'// 4.16 To create a composited arrow object
  DECLARE SUB ZI_CreateArrowObject LIB "GDIMAGE.DLL" ALIAS "ZI_CreateArrowObject" ( _
  zDetail AS ZOBJECT, _                ' Reference to the matching ZOBJECT structure.
  byval SeedX as long, _               ' Swap SeedX and TargetX to select arrow orientation.
  byval SeedY as long, _               ' Swap SeedY and TargetY to select arrow orientation.
  byval TargetX as long, _             ' Swap TargetX and SeedX to select arrow orientation.
  byval TargetY as long, _             ' Swap TargetY and SeedY to select arrow orientation.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval BorderSize as long, _          ' Size of the border (can be NULL).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE.
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  )

'// 4.16 To create a composited ellipse object
  DECLARE SUB ZI_CreateEllipseObject LIB "GDIMAGE.DLL" ALIAS "ZI_CreateEllipseObject" ( _
  zDetail AS ZOBJECT, _                ' Reference to the matching ZOBJECT structure.
  byval TopLeftX as long, _            ' The top X of the rectangular region matching the ellipse size.
  byval TopLeftY as long, _            ' The top Y of the rectangular region matching the ellipse size.
  byval BottomRightX as long, _        ' The bottom X of the rectangular region matching the ellipse size.
  byval BottomRightY as long, _        ' The bottom Y of the rectangular region matching the ellipse size.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval BorderSize as long, _          ' Size of the border (can be NULL).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE.
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  )

'// 4.16 To create a composited curve object
  DECLARE SUB ZI_CreateCurveObject LIB "GDIMAGE.DLL" ALIAS "ZI_CreateCurveObject" ( _
  zDetail AS ZOBJECT, _                ' Reference to the matching ZOBJECT structure.
  byval pXY AS ZPOINTS PTR, _          ' Pointer to an ARRAY of POINTS (holding x,y coordinates of each point).
  byval ArraySize as long, _           ' UBOUND - LBOUND + 1 = number of point in the array.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval PenSize as long, _             ' Size of the pen.
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE (see below).
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  )

'// 4.16 To create a composited PolyLine object
  DECLARE SUB ZI_CreatePolyLineObject LIB "GDIMAGE.DLL" ALIAS "ZI_CreatePolyLineObject" ( _
  zDetail AS ZOBJECT, _                ' Reference to the matching ZOBJECT structure.
  byval pXY AS ZPOINTS PTR, _          ' Pointer to an ARRAY of POINTS (holding x,y coordinates of each point).
  byval ArraySize as long, _           ' UBOUND - LBOUND + 1 = number of point in the array.
  byval ColrARGB as long, _            ' The ARGB color to use.
  byval PenSize as long, _             ' Size of the pen.
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  byval ZD_STYLE as long, _            ' The object Drawing STYLE (see below).
  OPTIONAL byval Use3D as long _       ' The shadow 3D offset.
  )

'// 4.16 To create a composited image
  DECLARE FUNCTION ZI_CreateImageComposited LIB "GDIMAGE.DLL" ALIAS "ZI_CreateImageComposited" ( _
  zImageDest as asciiz, _              ' Name of the file to save the resulting composited image: 
  byval xW as long, _                  ' Bound Width of the resulting composited image.
  byval yH as long, _                  ' Bound Height of the resulting composited image.
  byval pSprite AS ZOBJECT PTR, _      ' Pointer to the ZOBJECT array structure
  byval N as long _                    ' The ZOBJECT array count.
  ) as long
' Note: 
' If zImageDest is NULL then the function returns a bitmap handle, 
' then the calling application is responsible to delete the bitmap handle.

'// 4.16
' Get the number of frames embedded into the image list object.
  DECLARE FUNCTION ZD_GetObjectFrameCount LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectFrameCount" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long

'// 4.16
' Set the number of frames embedded into the image list object.
  DECLARE SUB ZD_SetObjectFrameCount LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectFrameCount" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval nCount as long _               ' The horizontal image list count
  )

'// 4.16
' Get the range of the current active frame into the image list object.
  DECLARE FUNCTION ZD_GetObjectFrameToUse LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectFrameToUse" ( _
  byval ObjID as long _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) as long

'// 4.16
' Set the range of the current active frame into the image list object.
  DECLARE SUB ZD_SetObjectFrameToUse LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectFrameToUse" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval nImageToUse as long, _         ' The image to use in the list.
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )

'// 4.16
' Low level drawing API allowing to use the full range of GDImage ZOBJECT color settings attributes.
  DECLARE SUB ZI_RenderAttributes LIB "GDIMAGE.DLL" ALIAS "ZI_RenderAttributes" ( _
  byval hDCdest as long, _    ' Handle to destination DC.
  byval xDest as long, _      ' X-coord of destination upper-left corner.
  byval yDest as long, _      ' Y-coord of destination upper-left corner.
  byval DestWidth as long, _  ' Width of destination rectangle.
  byval DestHeight as long, _ ' Height of destination rectangle.
  byval hDCsrce as long, _    ' Handle to source DC.
  byval xSrce as long, _      ' X-coord of source upper-left corner.
  byval ySrce as long, _      ' Y-coord of source upper-left corner.
  byval SrceWidth as long, _  ' Width of source rectangle.
  byval SrceHeight as long, _ ' Height of source rectangle.
  byval nAlpha as long, _     ' 0-255 Alpha channel value, use 255 = opaque 
  zObjItem AS ZOBJECT _       ' To use extended GDImage attrivutes
  )

'// 5.00
  DECLARE SUB GL_DrawCup LIB "GDIMAGE.DLL" ALIAS "GL_DrawCup" ( _
  byval sRadius AS SINGLE, _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawDome LIB "GDIMAGE.DLL" ALIAS "GL_DrawDome" ( _
  byval sRadius AS SINGLE, _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawCylinder LIB "GDIMAGE.DLL" ALIAS "GL_DrawCylinder" ( _
  byval Radius AS SINGLE, _
  byval Value AS SINGLE, _
  byval R1 AS SINGLE, _
  byval R2 AS SINGLE, _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawDisk LIB "GDIMAGE.DLL" ALIAS "GL_DrawDisk" ( _
  byval sRadius AS SINGLE, _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawSphere LIB "GDIMAGE.DLL" ALIAS "GL_DrawSphere" ( _
  byval sRadius AS SINGLE, _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawCubeFrontFace LIB "GDIMAGE.DLL" ALIAS "GL_DrawCubeFrontFace" ( _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawCubeBackFace LIB "GDIMAGE.DLL" ALIAS "GL_DrawCubeBackFace" ( _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawCubeTopFace LIB "GDIMAGE.DLL" ALIAS "GL_DrawCubeTopFace" ( _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawCubeBottomFace LIB "GDIMAGE.DLL" ALIAS "GL_DrawCubeBottomFace" ( _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawCubeRightFace LIB "GDIMAGE.DLL" ALIAS "GL_DrawCubeRightFace" ( _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawCubeLeftFace LIB "GDIMAGE.DLL" ALIAS "GL_DrawCubeLeftFace" ( _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_DrawCube LIB "GDIMAGE.DLL" ALIAS "GL_DrawCube" ( _
  byval nTexture as long _    ' The texture to use, or 0 to use the current one. 
  )

'// 5.00
  DECLARE SUB GL_CreateContext LIB "GDIMAGE.DLL" ALIAS "GL_CreateContext" ( _
  byval nWidth as long, _      ' The DIB bitmap width.
  byval nHeight as long _      ' The DIB bitmap height.
  )
' See also: GL_DeleteContext

'// 5.00
  DECLARE FUNCTION GL_GLDC LIB "GDIMAGE.DLL" ALIAS "GL_GLDC" () as long
' Return: The GDImage DIB DC.

'// 5.00
  DECLARE FUNCTION GL_GLRC LIB "GDIMAGE.DLL" ALIAS "GL_GLRC" ()  as long
' Return: The OpenGL Rendering Context.

'// 5.00
' To delete all resources created with GL_CreateContext.
  DECLARE SUB GL_DeleteContext LIB "GDIMAGE.DLL" ALIAS "GL_DeleteContext" ( _
  BYREF hGLDC as long, _
  BYREF hGLRC as long _
  )

'// 5.00
  DECLARE SUB GL_AlphaBlend LIB "GDIMAGE.DLL" ALIAS "GL_AlphaBlend" ( _
  byval hDcDest as long, _
  byval hDcSrce as long _
  )

'// 5.00
  DECLARE FUNCTION GL_CreateDrawingDC LIB "GDIMAGE.DLL" ALIAS "GL_CreateDrawingDC" ( _
  byval nWidth as long, _      ' The DIB width.
  byval nHeight as long _      ' The DIB height.
  ) as long

'// 5.00
  DECLARE FUNCTION ZD_ComputeObjectAngleFromPoint LIB "GDIMAGE.DLL" ALIAS "ZD_ComputeObjectAngleFromPoint" ( _
  byval ObjID as long, _
  byval x as long, _
  byval y as long _
  ) as long

'// 5.00
  DECLARE SUB ZI_DestroyDW LIB "GDIMAGE.DLL" ALIAS "ZI_DestroyDW" ( _
  BYREF hDW as long _          ' The Disabled Window handle to destroy
  )

'//5.00
  DECLARE FUNCTION ZI_CreateImageFromBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_CreateImageFromBitmap" ( _
  byval hBmp as long _
  ) as long

'//Change in version 5.00
' No more need to use ZD_UsePngOpacity to use ALPHA channel.
' OpenGL 3D primitives.
' Sprite multi-state.
' Create a composited bitmap directly in memory.

'//5.01
' To anchor a specific GDImage sprite object.
' Note: it uses a limited subset of the %ANCHOR flags,
'       because you can't change the width or the height of a sprite object with any of %ANCHOR_WIDTH or %ANCHOR_HEIGHT
  DECLARE FUNCTION ZD_SetObjectAnchorMode LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectAnchorMode" ( _
  byval nObjID as long, _
  byval AnchorMode as long _
  ) as long

'//////////////////////////////////////////////////////////////////////////////////////////
' Undocumented features

'//5.02
' Get the frame count of a GDIPLUS image. 
  DECLARE FUNCTION ZI_GetImageFrameCount LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageFrameCount" ( _
  byval Img as long _       ' A valid GDImage - GDIPLUS handle.
  ) as long

'//5.02
' Convert a multi-frame GDIPLUS image, into a multi-state GDImage.
  DECLARE FUNCTION ZI_CreateMultiFrameImage LIB "GDIMAGE.DLL" ALIAS "ZI_CreateMultiFrameImage" ( _
  byval Img as long, _      ' A valid GDImage - GDIPLUS handle.
  byval nUseBit as long, _  ' Either 24 or 32-bit.
  byval nFit as long _      ' To use square frames suitable to perform image rotation. 
  ) as long

'//5.03
  DECLARE FUNCTION ZD_GetObjectLinked LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectLinked" ( _
  byval nObjID as long _
  ) as long

'//5.03
  DECLARE SUB ZD_SetObjectLinked LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectLinked" ( _
  byval nObjID as long, _
  byval LinkedID as long _
  )

'//5.04
' This API works like ZD_SetObjectXY, 
' however its mains purpose is to move linked objects with the keyboard in a GDImageCallback
  DECLARE SUB ZD_MoveLinkedObject LIB "GDIMAGE.DLL" ALIAS "ZD_MoveLinkedObject" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  byval x as long, _                   ' The X coordinate
  byval y as long, _                   ' The Y coordinate
  byval RedrawParent as long _         ' TRUE causes immediate redraw of the object parent.
  )

'//5.06
' Assign a new texture to an existing OpenGL "Named texture".
  DECLARE FUNCTION ZI_UpdateNamedGLTextureFromFileEx LIB "GDIMAGE.DLL" ALIAS "ZI_UpdateNamedGLTextureFromFileEx" ( _
  zFullName as asciiz, _        ' Full qualified path name.
  byval NamedTexture as long, _ ' An existing OpenGL NamedTexture
  byval SquareMode as long _    ' The square mode to use
  ) as long
' Return:
' An OpenGL error code in case of Error.

  DECLARE FUNCTION ZI_LoadDLL LIB "GDIMAGE.DLL" ALIAS "ZI_LoadDLL" (zUserName as asciiz) as long

'// 5.15 Enable/Disable drawing of the WinLIFT skin background in the specified GDImage graphic control. 
  DECLARE SUB ZI_UseWinLIFTbackground LIB "GDIMAGE.DLL" ALIAS "ZI_UseWinLIFTbackground" ( _
  byval hGDImageCtrl as long, _ ' The GDimage control handle.
  byval TrueOrFalse as long, _  ' The enable/disable boolean value to use.
  byval RedrawParent as long _  ' TRUE causes immediate redraw of the object parent.
  )

'// 5.16 Date and time when the original image data was generated
' The format is YYYY:MM:DD HH:MM:SS with time shown in 24-hour format and the date and time separated by one blank character.
  DECLARE FUNCTION ZI_GetExifDTOrig LIB "GDIMAGE.DLL" ALIAS "ZI_GetExifDTOrig" ( _
  zImgName as asciiz _          ' Full qualified path name.
  ) AS STRING

'// 5.20 Replace an existing ARGB color with a new ARGB color (using alpha channel)
  DECLARE SUB ZI_ReplaceARGBColorBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_ReplaceARGBColorBitmap" ( _
  byval hBmp as long, _         ' A valid bitmap handle.     
  byval WasARGB as long, _      ' ARGB Pixel color to replace 
  byval NewARGB as long _       ' New ARGB pixel color        
  )

'// 5.21 Get the image info property count from a GDIPLUS handle.
  DECLARE FUNCTION ZI_GetImageInfoCount LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageInfoCount" ( _
  byval Img as long _           ' A valid GDImage - GDIPLUS EXIF handle.
  ) as long                     ' RETURN: The property count.

'// 5.21 Get detailed info about a specific TAG property.
  DECLARE FUNCTION ZI_GetImageInfoString LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageInfoString" ( _
  byval Img as long, _          ' A valid GDImage - GDIPLUS EXIF handle.
  byval nProperty as long _     ' The TAG property to retrieve.
  ) AS STRING                   ' RETURN: a detailed string matching the TAG property.

'// 5.21 Retrieve the complete list of properties from an EXIF image. 
  DECLARE FUNCTION ZI_GetImageInfoList LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageInfoList" ( _
  byval Img as long, _          ' A valid GDImage - GDIPLUS EXIF handle. 
  byval numOfProps as long, _   ' The number of properties to retrieve. 
  BYREF Arraylist as dword _    ' DWORD ptr to the array holding the retrieved values.
  ) as long  

'// 5.21 Get a specific EXIF image property.
  DECLARE FUNCTION ZI_GetImageInfoProperty LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageInfoProperty" ( _
  byval Img as long, _          ' A valid GDImage - GDIPLUS EXIF handle. 
  byval nID as dword, _         ' Property ID.
  byval nLength as dword, _     ' Property size.
  byval nValue as dword _       ' Property value.
  ) as long

'// 5.21 Set a specific EXIF image property.
  DECLARE FUNCTION ZI_SetImageInfoProperty LIB "GDIMAGE.DLL" ALIAS "ZI_SetImageInfoProperty" ( _
  byval Img as long, _          ' A valid GDImage - GDIPLUS EXIF handle. 
  byval nID as dword, _         ' Property ID.
  byval nLength as dword, _     ' Property size.
  byval nType AS WORD, _        ' Type of the value.
  byval nValue as dword _       ' Property value.
  ) as long

'// 5.21 Clone a GDIPLUS image.
  DECLARE FUNCTION zCloneImage LIB "GDIMAGE.DLL" ALIAS "zCloneImage" ( _
  byval Img as long _           ' A valid GDIPLUS handle.
  ) as long                     ' RETURN: the new clone image handle in case of success, null in case of error

'// 5.21 Remove an EXIF property.
  DECLARE FUNCTION ZI_RemoveImageInfoProperty ALIAS "ZI_RemoveImageInfoProperty" ( _
  byval Img as long, _          ' A valid GDImage - GDIPLUS EXIF handle. 
  byval nID as dword _          ' Property ID.
  ) as long

'// 5.25
  DECLARE FUNCTION ZI_SetFromFileEx LIB "GDIMAGE.DLL" ALIAS "ZI_SetFromFileEx" ( _
  byval hGDImageCtrl as long, _ ' The GDImage control handle.
  zFullPathName as asciiz, _    ' Full path name to the graphic file to display
  byval nUseW as long, _        ' Maximum width
  byval nUseH as long _         ' Maximum height
  ) as long

'// 5.26
  DECLARE FUNCTION ZD_GetItemObjectAndColorAtXY LIB "GDIMAGE.DLL" ALIAS "ZD_GetItemObjectAndColorAtXY" ( _
  byval hGDImageCtrl as long, _ ' The GDImage control handle.
  byval nX as long, _           ' The X coordinate to check at.
  byval nY as long, _           ' The Y coordinate to check at.
  BYREF RGBColor as long _      ' Return the RGB color of the pixel matching the X,Y coordinates.
  ) as long                     ' RETURN the object ID

'// 5.27
  DECLARE FUNCTION ZI_SetCtrlBitmapBackground LIB "GDIMAGE.DLL" ALIAS "ZI_SetCtrlBitmapBackground" ( _
  byval hGDImageCtrl as long, _ ' The GDImage control handle.
  byval hBitmap as long _       ' A valid BITMAP handle.
  ) as long                     ' RETURN: TRUE in case of succes, FALSE if error.

'// 5.32 CreateSkinBackgroundEx
  %PAINT_TILING_MODE        = 0
  %PAINT_STRETCH_MODE       = 1
  %PAINT_STRETCH_LEFT_RIGHT = 2
  %PAINT_STRETCH_TOP_BOTTOM = 4
  DECLARE FUNCTION ZI_SIZEL LIB "GDIMAGE.DLL" ALIAS "ZI_SIZEL" (byval nSize as long, byval RW as long) as long

  DECLARE FUNCTION ZI_SIZET LIB "GDIMAGE.DLL" ALIAS "ZI_SIZET" (byval nSize as long, byval RW as long) as long

  DECLARE FUNCTION ZI_SIZER LIB "GDIMAGE.DLL" ALIAS "ZI_SIZER" (byval nSize as long, byval RW as long) as long

  DECLARE FUNCTION ZI_SIZEB LIB "GDIMAGE.DLL" ALIAS "ZI_SIZEB" (byval nSize as long, byval RW as long) as long

  DECLARE SUB ZI_ComputeAspect LIB "GDIMAGE.DLL" ALIAS "ZI_ComputeAspect" (byval xPicSize as long, byval yPicSize as long, byval xCell as long, byval yCell as long, BYREF xPos as long, BYREF yPos as long, BYREF xSize as long, BYREF ySize as long)


'// 5.33
' Create a TEXT overlay object.
' Each overlay object must have a unique identifier.
' TEXT overlay is independant of the image background that is not altered.
  DECLARE FUNCTION ZD_DrawTextToCtrlEx LIB "GDIMAGE.DLL" ALIAS "ZD_DrawTextToCtrlEx" ( _
  byval hGDImageCtrl as long, _        ' The GDImage control handle.
  zUseText as asciiz, _                ' The text to display.
  byval x as long, _                   ' Top left X coordinate.
  byval y as long, _                   '// 5.33 Top left Y coordinate.
  byval w as long, _                   '// 5.33 Width.
  byval h as long, _                   ' Height.
  byval ColrARGB as long, _            ' The ARGB color to use.
  zUseFont as asciiz, _                ' The "Tue Type Font" name to use.
  byval UseSize as long, _             ' The size of the font in pixel.
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  byval ZS_STYLE as long, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  OPTIONAL byval UseShadow as long, _  ' The shadow 3D offset.
  OPTIONAL byval Orientation as long _ ' The text orientation (%ZD_TextHorzUp, %ZD_TextVertUp, %ZD_TextVertDn).
  ) as long
' Return:
' TRUE (-1) if success, FALSE (0) if error.

'// 5.33
' To change the text on the fly when text sprite has been created with ZD_DrawTextToCtrlEx.
  DECLARE SUB ZD_SetObjectTextEx LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectTextEx" ( _
  byval ObjID as long, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  zUseText as asciiz, _                ' The text to display
  byval RedrawParent as long _
  )

'// 5.33
' To change the font size on the fly when text sprite has been created with ZD_DrawTextToCtrlEx.
 DECLARE SUB ZD_ChangeTextFontSize LIB "GDIMAGE.DLL" ALIAS "ZD_ChangeTextFontSize" ( _
 byval hCtrl as long, _
 byval ObjID as long, _
 byval UseSize as long _
 )

'// 5.34
 DECLARE SUB GL_DrawText LIB "GDIMAGE.DLL" ALIAS "GL_DrawText" ( _
 byval glWnd as long, _
 UseFont AS ZGLFONT, _
 byval rX AS SINGLE, _
 byval rY AS SINGLE, _
 byval rZ AS SINGLE, _
 zTxt as asciiz, _
 byval ARGB as long _
 )

''// 6.00 Obsolete see below GL_TexSpec (to avoid conflict with the constant %GL_SPECULAR)
' DECLARE SUB GL_Specular LIB "GDIMAGE.DLL" ALIAS "GL_Specular" ( _
' byval nMode as long _ ' On Off mode
' )

'// 6.02
 DECLARE SUB GL_TexSpec LIB "GDIMAGE.DLL" ALIAS "GL_TexSpec" ( _
 byval nMode as long _ ' On Off mode
 )

'// 6.00
 DECLARE SUB GL_DrawQuad LIB "GDIMAGE.DLL" ALIAS "GL_DrawQuad" ( _
 byval x AS SINGLE, _
 byval y AS SINGLE, _
 byval z AS SINGLE _
 )

'// 6.00
 DECLARE SUB GL_ChartCylinder LIB "GDIMAGE.DLL" ALIAS "GL_ChartCylinder" ( _
 byval radius AS SINGLE, _
 byval height AS SINGLE, _
 byval slices as long, _
 byval stacks as long _
 )

'// 6.00
 DECLARE SUB GL_ChartBar LIB "GDIMAGE.DLL" ALIAS "GL_ChartBar" ( _
 byval rX AS SINGLE, _
 byval rY AS SINGLE, _
 byval rZ AS SINGLE _
 )

'// 6.00
 DECLARE SUB GL_ChartAxis LIB "GDIMAGE.DLL" ALIAS "GL_ChartAxis" ( _
 byval rX AS SINGLE, _
 byval rY AS SINGLE, _
 byval rZ AS SINGLE _
 )

'// 6.00
 DECLARE SUB GL_ChartAxisPanel LIB "GDIMAGE.DLL" ALIAS "GL_ChartAxisPanel" ( _
 byval rX AS SINGLE, _
 byval rY AS SINGLE, _
 byval rZ AS SINGLE _
 )

'// 6.00
 DECLARE SUB GL_ChartPyramide LIB "GDIMAGE.DLL" ALIAS "GL_ChartPyramide" ( _
 byval rX AS SINGLE, _
 byval rZ AS SINGLE _
 )

'// 6.00
 DECLARE SUB GL_ChartRing LIB "GDIMAGE.DLL" ALIAS "GL_ChartRing" ( _
 byval RING_MINOR AS SINGLE, _
 byval RING_MAJOR AS SINGLE, _
 byval RING_MINOR_RES AS SINGLE, _
 byval RING_MAJOR_RES AS SINGLE _
 )

'// 6.00
 DECLARE FUNCTION GL_UseMouseManager LIB "GDIMAGE.DLL" ALIAS "GL_UseMouseManager" ( _
 byval GLwnd as dword _
 ) as dword


'// 6.00
 DECLARE FUNCTION GL_CreateFontTexture LIB "GDIMAGE.DLL" ALIAS "GL_CreateFontTexture" ( _
 byval glWnd as long, _
 zUseFont as asciiz, _
 byval nfontSize as long, _
 byval ColrARGB as long _
 ) as long

'// 6.00
 DECLARE SUB GL_DeleteTextureFont LIB "GDIMAGE.DLL" ALIAS "GL_DeleteTextureFont" ( _
 byval glWnd as long _
 )

'// 6.00
 DECLARE SUB GL_ChartLabel LIB "GDIMAGE.DLL" ALIAS "GL_ChartLabel" ( _
 byval glWnd as long, _
 byval UseFont as long, _
 byval x AS SINGLE, _
 byval y AS SINGLE, _
 byval z AS SINGLE, _
 zTxt as asciiz _
 )

'// 6.00
 DECLARE FUNCTION GL_GetSpecularMode LIB "GDIMAGE.DLL" ALIAS "GL_GetSpecularMode" ( _
 ) as long

'// 6.00
 DECLARE SUB GL_BindTexture LIB "GDIMAGE.DLL" ALIAS "GL_BindTexture" ( _
 byval nTextureMode as long, _
 byval nTextureToUse as long _
 )

'// 6.00
 DECLARE FUNCTION GL_GetActiveTexture LIB "GDIMAGE.DLL" ALIAS "GL_GetActiveTexture" ( _
 ) as long

'// 6.00
 DECLARE FUNCTION GL_ChartGetFontName LIB "GDIMAGE.DLL" ALIAS "GL_ChartGetFontName" ( _
 byval UseFont as long _
 ) AS STRING

'// 6.00
 DECLARE SUB GL_ChartSymbol LIB "GDIMAGE.DLL" ALIAS "GL_ChartSymbol" ( _
 byval glWnd as long, _
 byval UseFont as long, _
 byval x AS SINGLE, _
 byval y AS SINGLE, _
 byval z AS SINGLE, _
 zTxt as asciiz _
 )

'// 6.02
 DECLARE FUNCTION GL_ChartGetTextLength LIB "GDIMAGE.DLL" ALIAS "GL_ChartGetTextLength" ( _
 byval UseFont as long, _
 zTxt as asciiz _
 ) AS SINGLE

'// 6.02
 DECLARE SUB GL_ChartSetMousing LIB "GDIMAGE.DLL" ALIAS "GL_ChartSetMousing" ( _
 byval rChartXoff AS SINGLE, _
 byval rChartYoff AS SINGLE, _
 byval rChartZoff AS SINGLE, _
 byval rChartZoom AS SINGLE, _
 byval rChartXrot AS SINGLE, _
 byval rChartYrot AS SINGLE _
 )

'// 6.02
 DECLARE SUB GL_ChartGetMousing LIB "GDIMAGE.DLL" ALIAS "GL_ChartGetMousing" ( _
 rChartXoff AS SINGLE, _
 rChartYoff AS SINGLE, _
 rChartZoff AS SINGLE, _
 rChartZoom AS SINGLE, _
 rChartXrot AS SINGLE, _
 rChartYrot AS SINGLE _
 )

'// 6.02
 DECLARE SUB GL_ChartSphere LIB "GDIMAGE.DLL" ALIAS "GL_ChartSphere" ( _
 byval rRadius AS SINGLE, _
 byval rValue AS SINGLE, _  
 byval nCompile as long _      '// Set it to TRUE to compile and reduce CPU impact
 )

'// 6.03
 DECLARE SUB GL_Cylinder LIB "GDIMAGE.DLL" ALIAS "GL_Cylinder" ( _
 byval radiusBottom AS SINGLE, _
 byval radiusTop AS SINGLE, _
 byval height AS SINGLE, _
 byval slices as long, _
 byval stacks as long, _ 
 byval UseOperculum as long _  '// True = solid cylinder, False = tube.
 )

'// 6.03
 DECLARE SUB GL_ChartCone LIB "GDIMAGE.DLL" ALIAS "GL_ChartCone" ( _
 byval radius AS SINGLE, _
 byval height AS SINGLE, _
 byval slices as long, _
 byval stacks as long _
 )

 %CHART_MIN      = 1
 %CHART_BAR      = %CHART_MIN
 %CHART_CYLINDER = 2
 %CHART_PYRAMIDE = 3
 %CHART_SPHERE   = 4
 %CHART_CONE     = 5
 %CHART_POINT    = 6
 %CHART_MAX      = %CHART_POINT

 TYPE ZCHART_PARAM
     nType       as long    '// Type of graph (%CHART_Bar, %CHART_Cylinder, %CHART_Sphere, etc)
     rValue      AS SINGLE
     nColor      as long
     nTexSpec    as long    '// %TRUE or %FALSE to Enable/Disable specular texture mode.
     nList       as long
     nTexture    as long

     'X           AS SINGLE
     'Y           AS SINGLE
     'Z           AS SINGLE  '

 END TYPE

'// 6.03
 DECLARE SUB GL_ChartPoint LIB "GDIMAGE.DLL" ALIAS "GL_ChartPoint" ( _
 byval rRadius AS SINGLE, _
 byval rValue AS SINGLE _
 )

'// 6.04
 DECLARE SUB GL_BillBoard LIB "GDIMAGE.DLL" ALIAS "GL_BillBoard" ( _
 )

'// 6.04 Create antialiased control.
 DECLARE FUNCTION WGL_CreateWindow LIB "GDIMAGE.DLL" ALIAS "WGL_CreateWindow" ( _
 byval dwExStyle as dword, _
 byval dwStyle as dword, _
 byval x as long, byval y as long, _
 byval nWidth as long, byval nHeight as long, _
 byval hWndParent as dword, _
 byval CtrlID as dword _
 ) as dword

'// 6.04
 DECLARE FUNCTION GL_MultiSampleARB LIB "GDIMAGE.DLL" ALIAS "GL_MultiSampleARB" ( _
 ) as long

'// 6.05 Wavefront OBJ support

  %SHADER_BLINN_PHONG    = 1
  %SHADER_NORMAL_MAPPING = 2

TYPE Material
    ambient(0 TO 3)    AS SINGLE
    diffuse(0 TO 3)    AS SINGLE
    specular(0 TO 3)   AS SINGLE
    shininess          AS SINGLE '// (0 = min shininess, 1 = max shininess)
    alpha              AS SINGLE '// (0 = fully transparent, 1 = fully opaque)

    szMapName          as asciiz * 260 '// %MAX_PATH
    szColorMapFilename as asciiz * 260 '// %MAX_PATH
    szBumpMapFilename  as asciiz * 260 '// %MAX_PATH

    illum              as long

END TYPE

TYPE VertexT
    position(0 TO 2)   AS SINGLE
    texCoord(0 TO 1)   AS SINGLE
    normal(0 TO 2)     AS SINGLE
    tangent(0 TO 3)    AS SINGLE
    bitangent(0 TO 2)  AS SINGLE
END TYPE

TYPE Mesh
    startIndex         as long
    triangleCount      as long
    pMaterial          AS Material PTR
END TYPE

TYPE CacheT
    szCacheName        as asciiz * 260 '// %MAX_PATH
    nIter              as long
END TYPE

'// 6.08 Work the same than ZI_FitBitmapFromFile but from another bitmap instead of file.
 DECLARE FUNCTION ZI_FitBitmapFromBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_FitBitmapFromBitmap" ( _
 byval FromBitmap as long, _      ' Bitmap handle source
 byval UseW as long, _            ' Width of the container
 byval UseH as long _             ' Height of the container
 ) as long

'// 6.51
 DECLARE FUNCTION ZD_UpdatePoints LIB "GDIMAGE.DLL" ALIAS "ZD_UpdatePoints" ( _
 byval ObjectType as long, _      ' The object type (see ZD_GetObjectType).
 byval hCtrl as dword, _          ' The GDImage control container.
 byval ObjID as long, _           ' The unique object IDentifier (each object MUST USE A UNIQUE one).
 byval pXY AS ZPOINTS PTR, _      ' Pointer to an ARRAY of POINTS (holding x,y coordinates of each point).
 byval ArraySize as long _        ' UBOUND - LBOUND + 1 = number of point in the array.
 ) as long

'// 6.55
 DECLARE SUB ZI_SetMouseOverObjectID LIB "GDIMAGE.DLL" ALIAS "ZI_SetMouseOverObjectID" ( _
 byval nID as long _
 )

'// 6.56
 declare sub ZI_SpinnerClose lib "GDIMAGE.DLL" alias "ZI_SpinnerClose" ( _
 )

 declare function ZI_SpinnerInit lib "GDIMAGE.DLL" alias "ZI_SpinnerInit" ( _
 byval hParent as dword, _
 szFileName as asciiz, _
 byval nSpeedDelay as long _
 ) as dword

 declare function zSkiToImage lib "GDIMAGE.DLL" alias "zSkiToImage" ( _
 szFile as asciiz _
 ) as dword

 DECLARE FUNCTION ZI_FontBoxSpin LIB "GDIMAGE.DLL" ALIAS "ZI_FontBoxSpin" ( _
 byval hParent as long, _  ' The parent window handle.
 zCaption as asciiz, _     ' The font box caption.
 zUseText as asciiz, _     ' The string to edit.
 zUseFont as asciiz, _     ' The font to use.
 BYREF UseSize as long, _  ' The pixel size to use.
 BYREF ColrARGB as long, _ ' The ARGB color to use
 BYREF Use3D as long, _    ' The shadow 3D offset.
 zUseSpinner as asciiz _   ' The spinner to use.
 ) as long

'// 6.57
 declare sub GL_Perspective lib "GDImage.DLL" alias "GL_Perspective" ( _
 byval fovY as double, _
 byval aspect as double, _
 byval zNear as double, _
 byval zFar as double _
 )

'// 6.58
 declare sub GL_DrawCloud lib "GDImage.dll" alias "GL_DrawCloud" ( _
 byval rX1 as single, _
 byval nPixStep as long, _
 byval rPensize as single, _
 byval nW as long, _
 byval nH as long, _
 byval lpPixColor as dword, _
 byval lpAlpha as dword, _
 byval lpPalette as dword, _
 byval gPnMove as long _
 )

 declare sub GL_LookAt lib "GDImage.dll" alias "GL_LookAt" ( _
 byval eyeX as single, _
 byval eyeY as single, _
 byval eyeZ as single, _
 byval lookAtX as single, _
 byval lookAtY as single, _
 byval lookAtZ as single, _
 byval upX as single, _
 byval upY as single, _
 byval upZ as single _
 )

 declare function zGetPixels lib "GDImage.dll" alias "zGetPixels" ( _
 byval hBitmap as dword, _
 byval longPtr as dword ptr _
 ) as long

 declare function ZI_ApplyAlphaMask lib "GDImage.dll" alias "ZI_ApplyAlphaMask" ( _
 zInputName as asciiz, _
 zInputMask as asciiz, _
 zOutputName as asciiz _
 ) as long

 declare sub zCheckName lib "GDImage.dll" alias "zCheckName" ( _
 sImgName AS STRING _
 )

 '// 6.65 exported
 declare function zImageCtrlProc lib "GDImage.dll" alias "zImageCtrlProc" ( _
 byval hWnd as dword, _
 byval Msg as dword, _
 byval wParam as dword, _
 byval lParam as long _
 ) as long

 '// 6.70
 declare function ZI_DwmEnable lib "GDIMAGE.DLL" alias "ZI_DwmEnable" ( _
 byval hWnd as dword _
 ) as long
 '// 6.70
 declare function zSkiToDib lib "GDIMAGE.DLL" alias "zSkiToDib" ( _
 szFile as asciiz _
 ) as dword
 '// 6.70
 declare function zImageCtrlProc lib "GDIMAGE.DLL" alias "zImageCtrlProc" ( _
 byval hWnd as dword, _
 byval Msg as dword, _
 byval wParam as dword, _
 byval lParam as long _
 ) as long
 '// 6.70
 declare function ZI_SpinnerCreate lib "GDIMAGE.DLL" alias "ZI_SpinnerCreate" ( _
 byval hParent as dword, _
 szFileName as asciiz, _
 nSpeedDelay as long _
 ) as dword

 %ANIM = 1296649793
 type ANIHEADER
     nFrame   as word
     nWidth   as word
     nHeight  as word
     nSpeed   as word
     noffset  as dword
     reserved as dword
     nSign    as dword
 end type

 declare function ZI_IsPNGanimation lib "GDIMAGE.DLL" alias "ZI_IsPNGanimation" ( _
 szFile as asciiz _
 ) as long

 declare function ZI_GetPNGanimation lib "GDIMAGE.DLL" alias "ZI_GetPNGanimation" ( _
 szFile as asciiz, _
 byref anih as ANIHEADER _
 ) as long

 declare function ZI_LoadPNGanimation lib "GDIMAGE.DLL" alias "ZI_LoadPNGanimation" ( _
 szFile as asciiz, _
 byref anih as ANIHEADER _
 ) as dword